﻿	using System;using UnityEngine;using System.Collections;using System.Collections.Generic;using SimpleJSON;using System.Linq;using UnityEngine.UI;using UnityEngine.Windows.Speech;
namespace JayJayWon{
    public class ActionGrouper : MVRScript{
        const string pluginName = "ActionGrouper";const string pluginAuthor = "JayJayWon"; const string pluginVersion = "v1.9";
		public override void Init() {
			try {	
				_actSwitching=true;List<string> actionChoices = new List<string>();
				_hideVAMSaveRestoreActions = new JSONStorableBool("hideVAMSaveRestoreActions", true);			
				var btn = CreateButton("Execute Actions"); btn.button.onClick.AddListener(() =>{StartActions();});_startActions = new JSONStorableAction("Execute", () =>{StartActions();}); RegisterAction(_startActions);
				_enableAutoStart = new JSONStorableBool("Auto Execute on Scene Load",false);_enableAutoStart.storeType = JSONStorableParam.StoreType.Physical;RegisterBool(_enableAutoStart);var toggle = CreateToggle(_enableAutoStart);					
                _bulkOpJSON = new JSONStorableStringChooser("bulkOperation", null, null, "", SwitchBulkOp);	_bulkOpTargetJSON = new JSONStorableStringChooser("bulkOperationTarget", null, null, "", SwitchBulkOpTarget);_bulkOpJSON.val = "Copy Acts From";_importPluginJSON = new JSONStorableStringChooser("importPlugin", GetImportPluginChoices(), "None", "ImportPlugin");_pluginVersionJSON = new JSONStorableString("PluginVersion","");_pluginVersionJSON.val = pluginName +" "+pluginVersion + "\nby "+pluginAuthor;
				_whenConditionJSON = new JSONStorableStringChooser("whenCondition", GetWhenConditionChoices(), "On Execute Only", "Execute WHEN",(string temp)=>{LeftUIRefresh();if (_whenConditionJSON.val.Length>4 && _whenConditionJSON.val.Substring(0,5)=="vBOOL"){_whenVBOOLStartState = GetWhenBoolState ();}});_whenConditionJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterStringChooser(_whenConditionJSON);
				_whenVUMLPluginJSON = new JSONStorableStringChooser("whenVUMLPlugin", null, "", "VUML Plugin",(string temp)=>{LeftUIPluginRefresh();SpeechTextUpdate(_speechTextJSON.val);_whenVBOOLStartState = GetWhenBoolState ();});_whenVUMLPluginJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterStringChooser(_whenVUMLPluginJSON);
				_ifConditionJSON = new JSONStorableStringChooser("ifCondition", GetIfConditionChoices(), "Always", "Execute\nIF",(string temp)=>{LeftUIRefresh();});_ifConditionJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterStringChooser(_ifConditionJSON);
				_ifVUMLPluginJSON = new JSONStorableStringChooser("ifVUMLPlugin", null, "", "VUML Plugin",(string temp)=>{LeftUIIfPluginRefresh();});_ifVUMLPluginJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterStringChooser(_ifVUMLPluginJSON);
				_speechTextJSON = new JSONStorableString("SpeechText","",SpeechTextUpdate);_speechTextJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterString(_speechTextJSON);
				_speechHighConfidenceJSON = new JSONStorableBool("SpeechHighConfidence",false);_speechHighConfidenceJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterBool(_speechHighConfidenceJSON);			
				_speechTextUpdatedJSON = new JSONStorableBool("SpeechTextUpdate",false);_speechTextUpdatedJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterBool(_speechTextUpdatedJSON);
				_phraseRecogniserActiveJSON = new JSONStorableBool("PhraseRecogniserActive",false);_phraseRecogniserActiveJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterBool(_phraseRecogniserActiveJSON);				
				_whenVUMLVariableJSON = new JSONStorableStringChooser("whenVUMLVariable", null, "", "VUML BOOL Variable",(string temp)=>{_whenVBOOLStartState = GetWhenBoolState ();});_whenVUMLVariableJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterStringChooser(_whenVUMLVariableJSON);
				_ifVUMLVariableJSON = new JSONStorableStringChooser("ifVUMLVariable", null, "", "VUML BOOL Variable");_ifVUMLVariableJSON.storeType = JSONStorableParam.StoreType.Physical;RegisterStringChooser(_ifVUMLVariableJSON);		
				LeftUIRefresh();				
                _currentActionChooser = new JSONStorableStringChooser("actionChooser", actionChoices, null, "Action", SwitchAction);
                _probabilityWeight = new JSONStorableFloat("Execution Probability", 1f,SyncProb, 0f, 1f,true);
				_atom1JSON = new JSONStorableStringChooser("atom", SuperController.singleton.GetAtomUIDs(), null, "Atom", SyncAtom1);
				_receiverGroup1JSON = new JSONStorableStringChooser("receiverGroup", null, null, "ReceiverGroup", SyncReceiverGroup1);
				_receiver1JSON = new JSONStorableStringChooser("receiver", null, null, "Receiver", SyncReceiver1);
				_target1JSON = new JSONStorableStringChooser("receiverTarget", null, null, "Target", Target1Select);		
				_targetValueSourceJSON = new JSONStorableStringChooser("targetValueSource", null, null, "Target Value Source", TargetValueSourceSelect);
				_targetVUMLVariableNameJSON = new JSONStorableStringChooser("targetVUMLVarName", null, null, "Target Value (VUML)", TargetVUMLVarSelect);				
				_target1ValueChoicesJSON = new JSONStorableStringChooser("targetValue", null, null, "TargetValue", Target1ValueSelect);
				_target1ValueFloatJSON = new JSONStorableFloat("TargetValueFloat", 0f, Target1FloatSelect, -1000f,1000f, false );
				_target1ValueFilePathStringJSON = new JSONStorableString ("TargetValueFilePathString","",Target1FileURLValueSelect);
				HSVColor hsvColor;hsvColor.H = 0f;hsvColor.S = 0f;hsvColor.V = 0f;
				_target1ValueColorJSON = new JSONStorableColor("TargetValueColor", hsvColor,Target1ColorSelect);
				_atomRenameHandle= new SuperController.OnAtomUIDRename(this.AtomNameUpdate);SuperController.singleton.onAtomUIDRenameHandlers += _atomRenameHandle;			
				_vamFilePath = Application.dataPath.Substring(0,Application.dataPath.Length-8).Replace('/','\\');
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
        public void CloseAllPopup(UIDynamicPopup exception){ if (_bulkOpPopup != null && _bulkOpPopup != exception) { _bulkOpPopup.popup.visible = false; }if (_bulkOpTargetPopup != null && _bulkOpTargetPopup != exception) { _bulkOpTargetPopup.popup.visible = false; }if (_displayActPopup != null && _displayActPopup != exception) { _displayActPopup.popup.visible = false; }if (_displayAtomPopup != null && _displayAtomPopup != exception) { _displayAtomPopup.popup.visible = false; } if (_displayReceiverGroupPopup != null && _displayReceiverGroupPopup != exception) { _displayReceiverGroupPopup.popup.visible = false; } if (_displayReceiverPopup != null && _displayReceiverPopup != exception) { _displayReceiverPopup.popup.visible = false; }if (_displayTargetPopup != null && _displayTargetPopup != exception) { _displayTargetPopup.popup.visible = false; } if (_displayTargetValueSourcePopup != null && _displayTargetValueSourcePopup != exception) { _displayTargetValueSourcePopup.popup.visible = false; } if (_displayTargetVUMLVarPopup != null && _displayTargetVUMLVarPopup != exception) { _displayTargetVUMLVarPopup.popup.visible = false; }if (_displayTargetValuePopup != null && _displayTargetValuePopup != exception) { _displayTargetValuePopup.popup.visible = false; }if (_selectActionGrouperPluginPopup != null && _selectActionGrouperPluginPopup != exception) { _selectActionGrouperPluginPopup.popup.visible = false; }if (_whenTriggerConditionPopup != null && _whenTriggerConditionPopup != exception) { _whenTriggerConditionPopup.popup.visible = false; }if (_whenVUMLPluginPopup != null && _whenVUMLPluginPopup != exception) { _whenVUMLPluginPopup.popup.visible = false; }if (_whenVUMLVariablePopup != null && _whenVUMLVariablePopup != exception) { _whenVUMLVariablePopup.popup.visible = false; } if (_ifConditionPopup != null && _ifConditionPopup != exception) { _ifConditionPopup.popup.visible = false; }if (_ifVUMLPluginPopup != null && _ifVUMLPluginPopup != exception) { _ifVUMLPluginPopup.popup.visible = false; }if (_ifVUMLVariablePopup != null && _ifVUMLVariablePopup != exception) { _ifVUMLVariablePopup.popup.visible = false; }}		
		protected void ImportFileSelected(string fileName){	try{
				if (fileName !="" && fileName.Length >=4 &&  fileName.Substring(fileName.Length-4,4)=="json"){
					List<string> pluginChoices = new List<string> ();
					JSONNode sceneJSON = this.LoadJSON(fileName);JSONArray atomsJSON =sceneJSON["atoms"].AsArray ;
					for (int atomIndex = 0; atomIndex < atomsJSON.Count; atomIndex++) {
						JSONArray storablesJSON = atomsJSON[atomIndex]["storables"].AsArray;
						for (int index = 0; index < storablesJSON.Count; index++){
							string storableID = (string)storablesJSON[index]["id"] ;int pluginNameStartIndex = storableID.IndexOf("_");
							if (storableID.Length>6 && pluginNameStartIndex >= 0 && storableID.Substring(pluginNameStartIndex,storableID.Length-pluginNameStartIndex)=="_JayJayWon.ActionGrouper") {pluginChoices.Add(atomsJSON[atomIndex]["id"]+">"+ storableID);}
						}
					}
					if (pluginChoices.Count == 0){pluginChoices.Add("None");_importFileName="";}else {_importFileName=fileName;}
					_importPluginJSON.choices= new List<string>();_importPluginJSON.choices = pluginChoices;_importPluginJSON.val = pluginChoices[0];	
				}					
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}	
		protected void LeftUIRefresh(){try{
			if (_whenTriggerConditionPopup !=null){RemovePopup(_whenTriggerConditionPopup);}
			if (_speechTextField!=null){RemoveTextField(_speechTextField);}		
			if (_speechHighConfidenceToggle!=null){RemoveToggle(_speechHighConfidenceToggle);}	
			_whenTriggerConditionPopup = CreateScrollablePopup(_whenConditionJSON,false);_whenTriggerConditionPopup.popupPanelHeight = 400f;_whenTriggerConditionPopup.popup.onOpenPopupHandlers += SyncWhenConditionChoices ;			
			if (_whenConditionJSON.val.Length>5 && _whenConditionJSON.val.Substring(0,5) == "vBOOL"){LeftUIPluginRefresh();}
			else {							
				if (_whenVUMLPluginPopup !=null){RemovePopup(_whenVUMLPluginPopup);}
				if (_whenVUMLVariablePopup !=null){RemovePopup(_whenVUMLVariablePopup);}
				if (_whenConditionJSON.val=="Speech Trigger"){_speechTextField = CreateTextInput(_speechTextJSON,false);_speechHighConfidenceToggle = CreateToggle (_speechHighConfidenceJSON,false);_speechHighConfidenceToggle.label = "High Confidence only";}
				LeftUIIfConditionRefresh();
			}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void LeftUIPluginRefresh(){try{
				if (_whenVUMLPluginPopup !=null){RemovePopup(_whenVUMLPluginPopup);}
				_whenVUMLPluginPopup = CreateScrollablePopup(_whenVUMLPluginJSON,false);_whenVUMLPluginPopup.popupPanelHeight = 400f;_whenVUMLPluginPopup.popup.onOpenPopupHandlers += SyncWhenVUMLPluginChoices ;
				if (!_actSwitching){
					SyncWhenVUMLPluginChoices();
					if (_whenVUMLPluginJSON.val=="" || !_whenVUMLPluginJSON.choices.Contains(_whenVUMLPluginJSON.val)){_whenVUMLPluginJSON.val = _whenVUMLPluginJSON.choices[0];}
				}
				LeftUIVUMLVarRefresh();
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void LeftUIVUMLVarRefresh(){try{
				if (_whenVUMLVariablePopup !=null){RemovePopup(_whenVUMLVariablePopup);}
 				_whenVUMLVariablePopup = CreateScrollablePopup(_whenVUMLVariableJSON,false);_whenVUMLVariablePopup.popupPanelHeight = 400f;_whenVUMLVariablePopup.popup.onOpenPopupHandlers += SyncWhenVUMLVariableChoices ;SyncWhenVUMLVariableChoices();LeftUIIfConditionRefresh();
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void LeftUIIfConditionRefresh(){try{
				if (_ifConditionPopup!=null){RemovePopup(_ifConditionPopup);}
				_ifConditionPopup = CreateScrollablePopup(_ifConditionJSON,false);_ifConditionPopup.popupPanelHeight = 250f;_ifConditionPopup.popup.onOpenPopupHandlers += SyncIfConditionChoices ;
				if (_ifConditionJSON.val.Length>5 && _ifConditionJSON.val.Substring(0,5) == "vBOOL"){LeftUIIfPluginRefresh();}
				else {
					if (_ifVUMLPluginPopup!=null){RemovePopup(_ifVUMLPluginPopup);}
					if (_ifVUMLVariablePopup!=null){RemovePopup(_ifVUMLVariablePopup);}
					LeftUIEndRefresh();
				}				
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void LeftUIIfPluginRefresh(){	try{
				if (_ifVUMLPluginPopup!=null){RemovePopup(_ifVUMLPluginPopup);}
				_ifVUMLPluginPopup = CreateScrollablePopup(_ifVUMLPluginJSON,false);_ifVUMLPluginPopup.popupPanelHeight = 400f;_ifVUMLPluginPopup.popup.onOpenPopupHandlers += SyncIfVUMLPluginChoices ;
				if (!_actSwitching){
					SyncIfVUMLPluginChoices();
					if (_ifVUMLPluginJSON.val=="" || !_ifVUMLPluginJSON.choices.Contains(_ifVUMLPluginJSON.val)){_ifVUMLPluginJSON.val = _ifVUMLPluginJSON.choices[0];}
				}
				LeftUIIfVUMLVarRefresh();
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void LeftUIIfVUMLVarRefresh(){try{
				if (_ifVUMLVariablePopup!=null){RemovePopup(_ifVUMLVariablePopup);}
 				_ifVUMLVariablePopup = CreateScrollablePopup(_ifVUMLVariableJSON,false);_ifVUMLVariablePopup.popupPanelHeight = 400f;_ifVUMLVariablePopup.popup.onOpenPopupHandlers += SyncIfVUMLVariableChoices ;SyncIfVUMLVariableChoices();
				if (_ifVUMLVariableJSON.val =="" || !_ifVUMLVariableJSON.choices.Contains(_ifVUMLVariableJSON.val)){_ifVUMLVariableJSON.val = _ifVUMLVariableJSON.choices[0];}
				LeftUIEndRefresh();
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}		
		protected void LeftUIEndRefresh(){try{
			if (_leftSpacer1 !=null){RemoveSpacer(_leftSpacer1);}
			if (_leftSpacer2 !=null){RemoveSpacer(_leftSpacer2);}
			if (_leftSpacer3 !=null){RemoveSpacer(_leftSpacer3);}
			if (_leftSpacer4 !=null){RemoveSpacer(_leftSpacer4);}
			if (_addActionButton !=null){RemoveButton(_addActionButton);}
			if (_copyActionButton !=null){RemoveButton(_copyActionButton);}
			if (_deleteActionButton !=null){RemoveButton(_deleteActionButton);}
			if (_executeBulkOpButton !=null){RemoveButton(_executeBulkOpButton);}
			if (_selectImportSceneButton !=null){RemoveButton(_selectImportSceneButton);}
			if (_importActionsButton !=null){RemoveButton(_importActionsButton);}
			if (_bulkOpPopup !=null){RemovePopup(_bulkOpPopup);}
			if (_bulkOpTargetPopup !=null){RemovePopup(_bulkOpTargetPopup);}
			if (_selectActionGrouperPluginPopup !=null){RemovePopup(_selectActionGrouperPluginPopup);}
			if (_pluginVersionTextField !=null){RemoveTextField(_pluginVersionTextField);}	
			_leftSpacer1 = CreateSpacer();_leftSpacer1.height = 15;			
			_addActionButton = CreateButton("Add Action"); _addActionButton.button.onClick.AddListener(() =>{AddAction();});
			_copyActionButton = CreateButton("Copy Action"); _copyActionButton.button.onClick.AddListener(() =>{CopyAction();});
			_deleteActionButton = CreateButton("Delete Action");_deleteActionButton.button.onClick.AddListener(() =>{DeleteAction();});
			_leftSpacer2 = CreateSpacer();_leftSpacer2.height = 15;	
			_bulkOpPopup = CreateScrollablePopup(_bulkOpJSON,false);_bulkOpPopup.popup.onOpenPopupHandlers += SyncBulkOps;_bulkOpPopup.popupPanelHeight = 400f;_bulkOpPopup.label = "Bulk Operation";			
			_bulkOpTargetPopup = CreateScrollablePopup(_bulkOpTargetJSON,false);_bulkOpTargetPopup.popup.onOpenPopupHandlers += SyncBulkOpTarget;_bulkOpTargetPopup.popupPanelHeight = 320f;_bulkOpTargetPopup.label = "Bulk Operation Target";		
			_executeBulkOpButton = CreateButton("Execute Bulk Operation"); _executeBulkOpButton.button.onClick.AddListener(() =>{ExecuteBulkOp();});
			_leftSpacer3 = CreateSpacer(false); _leftSpacer3.height = 15;
			_selectImportSceneButton = CreateButton("Select Import Scene");_selectImportSceneButton.button.onClick.AddListener(() =>{SuperController.singleton.GetScenePathDialog(ImportFileSelected);});	
			_selectActionGrouperPluginPopup = CreateScrollablePopup(_importPluginJSON,false);_selectActionGrouperPluginPopup.popupPanelHeight = 200f;_selectActionGrouperPluginPopup.label = "Action Grouper Plugin";
			_selectActionGrouperPluginPopup.popup.onOpenPopupHandlers += SyncImportActionGrouperPlugin;
			_importActionsButton = CreateButton("Import Actions from Scene");_importActionsButton.button.onClick.AddListener(() =>{ImportActions();});
			_leftSpacer4 = CreateSpacer(false); _leftSpacer4.height = 130;	
			_pluginVersionTextField = CreateTextField(_pluginVersionJSON,false);_pluginVersionTextField.height = 1;				
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void ImportActions(){	try{
				if (_importFileName !="" && _importFileName.Length>=4 && _importFileName.Substring(_importFileName.Length-4,4)=="json"){
					JSONNode sceneJSON = this.LoadJSON(_importFileName);int atomNameEndIndex = _importPluginJSON.val.IndexOf(">");string atomName =_importPluginJSON.val.Substring(0,atomNameEndIndex);string pluginName =_importPluginJSON.val.Substring(atomNameEndIndex+1);JSONArray atomsJSON =sceneJSON["atoms"].AsArray ;
					for (int atomIndex = 0; atomIndex < atomsJSON.Count; atomIndex++) {
						if ((string)atomsJSON[atomIndex]["id"]==atomName){							
							JSONArray storablesJSON = atomsJSON[atomIndex]["storables"].AsArray;
							for (int index = 0; index < storablesJSON.Count; index++){
								string storableID = (string)storablesJSON[index]["id"] ; int pluginNameStartIndex = storableID.IndexOf("_");
								if (storableID==pluginName) {LoadActions(storablesJSON[index],true);UpdateActChooserList();}
							}
						}
					}
				}				
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}	
		protected List<string> GetImportPluginChoices (){List<string> pluginChoices = new List<string> ();pluginChoices.Add("None");return (pluginChoices);}
		protected List<string> GetWhenConditionChoices (){List<string> whenCondChoices = new List<string> ();whenCondChoices.Add("On Execute Only");whenCondChoices.Add("vBOOL turns TRUE");whenCondChoices.Add("vBOOL turns FALSE");whenCondChoices.Add("vBOOL changes");whenCondChoices.Add("Speech Trigger");whenCondChoices.Add("Continuous");return (whenCondChoices);}
		protected List<string> GetIfConditionChoices (){List<string> ifCondChoices = new List<string> ();ifCondChoices.Add("Always");ifCondChoices.Add("vBOOL is TRUE");ifCondChoices.Add("vBOOL is FALSE");return (ifCondChoices);}
		protected void CreateReceiverUI(){		
			if (_displayAtomPopup != null) {RemovePopup(_displayAtomPopup);}if (_displayReceiverGroupPopup != null) {RemovePopup(_displayReceiverGroupPopup);}if (_displayReceiverPopup != null) {RemovePopup(_displayReceiverPopup);}if (_displayActPopup != null) {RemovePopup(_displayActPopup);}if (_displayProbSlider != null) {RemoveSlider(_displayProbSlider);}if (_displayActionUpButton != null) {RemoveButton(_displayActionUpButton);}if (_displayActionDownButton != null) {RemoveButton(_displayActionDownButton);} if (_spacer != null) {RemoveSpacer(_spacer);}
			string actionUpBtnLabel ="";string actionDownBtnLabel="" ;			
			if (_currentActionChooser.val == "Action 1" && _actCount >1){actionUpBtnLabel = "Move Action to Bottom of Order";}
			else {actionUpBtnLabel = "Move Action Up Order";}
			if (_currentActionChooser.val == "Action "+_actCount.ToString()&& _actCount >1){actionDownBtnLabel = "Move Action to Top of Order";}
			else {actionDownBtnLabel = "Move Action Down Order";}
			_displayActPopup = CreateScrollablePopup(_currentActionChooser,true);_displayActPopup.popupPanelHeight = 1100f;_displayActPopup.label = "Action";_displayActPopup.popup.onOpenPopupHandlers += SyncActChoices;
			_displayActionUpButton = CreateButton(actionUpBtnLabel,true);_displayActionUpButton.button.onClick.AddListener(() =>{ActionUp();});
			_displayActionDownButton = CreateButton(actionDownBtnLabel,true);_displayActionDownButton.button.onClick.AddListener(() =>{ActionDown();});
			_spacer = CreateSpacer(true);_spacer.height = 15;			
            _displayProbSlider = CreateSlider(_probabilityWeight,true);								
			_displayAtomPopup = CreateScrollablePopup(_atom1JSON,true);_displayAtomPopup.popupPanelHeight = 700f;_displayAtomPopup.popup.onOpenPopupHandlers += SyncAtom1Choices;_displayAtomPopup.label = "Atom";			
			if (GetCurrentActionAtom() !=null && GetCurrentActionAtom().category == "People"){
				_displayReceiverGroupPopup = CreateScrollablePopup(_receiverGroup1JSON,true);
				_displayReceiverGroupPopup.popupPanelHeight = 580f;
				_displayReceiverGroupPopup.popup.onOpenPopupHandlers += SyncReceiverGroup1Choices;
				_displayReceiverGroupPopup.label = "Receiver Group";
			}			
			_displayReceiverPopup = CreateScrollablePopup(_receiver1JSON,true);
			if (GetCurrentActionAtom() !=null && GetCurrentActionAtom().category == "People"){_displayReceiverPopup.popupPanelHeight = 480f;}
			else {_displayReceiverPopup.popupPanelHeight = 580f;}
			_displayReceiverPopup.popup.onOpenPopupHandlers += SyncReceiver1Choices;
			_displayReceiverPopup.label = "Receiver";
			CreateTargetUI();
		}
		protected void CreateTargetUI(){
			if (_displayTargetPopup != null) {RemovePopup(_displayTargetPopup);}if (_displayTargetValuePopup != null) {RemovePopup(_displayTargetValuePopup);}if (_displayTargetValueFloatPopup != null) {RemoveSlider(_displayTargetValueFloatPopup);}if (_displayTargetValueColorPopup != null) {RemoveColorPicker(_displayTargetValueColorPopup);}if (_displayLoadFilePath != null) {RemoveTextField(_displayLoadFilePath);}if (_displayFileSelectButton != null) {RemoveButton(_displayFileSelectButton);}if (_displayClearFileSelectButton != null) {RemoveButton(_displayClearFileSelectButton);}if (_displayTestActionButton != null) {RemoveButton(_displayTestActionButton);}if (_displayHSVRToggle != null) {RemoveToggle(_displayHSVRToggle);}if (_displayTargetValueSourcePopup != null) {RemovePopup(_displayTargetValueSourcePopup);}	if (_displayTargetVUMLVarPopup != null) {RemovePopup(_displayTargetVUMLVarPopup);}if (_spacer2 != null) {RemoveSpacer(_spacer2);}
			_displayTargetPopup = CreateScrollablePopup(_target1JSON,true);
			if (GetCurrentActionAtom() !=null && GetCurrentActionAtom().category == "People"){_displayTargetPopup.popupPanelHeight = 360f;}
			else {_displayTargetPopup.popupPanelHeight = 460f;}
			_displayTargetPopup.popup.onOpenPopupHandlers += SyncTarget1Choices;_displayTargetPopup.label = "Target";string targetType ="";
			if (_receiver1JSON.val == "Load Look/Pose/Preset") {targetType = "LOAD";}	
			else if (_receiver1 != null){targetType =  GetTargetType(_target1JSON.val,_receiver1);}
			else {targetType = "OTHER";}
			bool useVUML = false;
			if (targetType == "FLOAT" || targetType == "BOOL" || targetType == "STRING" || targetType == "CHOICE") {
				_displayTargetValueSourcePopup = CreateScrollablePopup(_targetValueSourceJSON,true);_displayTargetValueSourcePopup.popupPanelHeight = 400f;_displayTargetValueSourcePopup.popup.onOpenPopupHandlers += SyncTargetSourceChoices;
				if (_targetValueSourceJSON.val!="Static"){useVUML =true;_displayTargetVUMLVarPopup = CreateScrollablePopup(_targetVUMLVariableNameJSON,true);_displayTargetVUMLVarPopup.popupPanelHeight = 400f;_displayTargetVUMLVarPopup.popup.onOpenPopupHandlers += SyncTargetVUMLVar;}
			}
			if (!useVUML) {
				if (targetType == "FLOAT")	{_displayTargetValueFloatPopup = CreateSlider(_target1ValueFloatJSON,true);	}
				else if (targetType == "COLOR")	{_displayTargetValueColorPopup = CreateColorPicker(_target1ValueColorJSON,true);}
				else if (targetType == "STRING"){_displayLoadFilePath=CreateTextInput(_target1ValueFilePathStringJSON,true);_displayLoadFilePath.height = 1;}
				else if (targetType == "LOAD" || targetType == "URL"){
					_displayLoadFilePath = CreateTextField(_target1ValueFilePathStringJSON,true);_displayLoadFilePath.height = 1;_displayFileSelectButton = CreateButton("File Selection",true);
					_displayFileSelectButton.button.onClick.AddListener(() =>{
						SuperController.singleton.NormalizeMediaPath(_lastBrowseDir); // This sets the path if it exists
						string filetype =""; string folder ="" ;
						if (targetType == "LOAD"){
							string subTargetType = GetTargetType(_target1JSON.val,_receiver1);
							if (subTargetType == "LOADLOOK" || subTargetType == "LOADPOSE" || subTargetType == "LOADPRESET"){
								filetype="json";
								if (subTargetType == "LOADLOOK") {folder = "Saves\\Person\\appearance";}
								if (subTargetType == "LOADPOSE") {folder = "Saves\\Person\\pose";}
								if (subTargetType == "LOADPRESET") {folder = "Saves\\Person\\full";}
							}						
							else{
								filetype="vap";
								if (subTargetType=="LOADCLOTHPRESET"){folder = "Custom\\Atom\\Person\\Clothing";}
								if (subTargetType=="LOADAPPPRESET"){folder =  "Custom\\Atom\\Person\\Appearance";}
								if (subTargetType=="LOADGENPRESET"){folder =  "Custom\\Atom\\Person\\General";}
								if (subTargetType=="LOADHAIRPRESET"){folder =  "Custom\\Atom\\Person\\Hair";}
								if (subTargetType=="LOADMORPHPRESET"){folder = "Custom\\Atom\\Person\\Morphs";}
								if (subTargetType=="LOADBREASTPRESET"){folder = "Custom\\Atom\\Person\\BreastPhysics";}
								if (subTargetType=="LOADGLUTEPRESET"){folder =  "Custom\\Atom\\Person\\GlutePhysics";}
								if (subTargetType=="LOADSKINPRESET"){folder =  "Custom\\Atom\\Person\\Skin";}
								if (subTargetType=="LOADPOSEPRESET"){folder =  "Custom\\Atom\\Person\\Pose";}
							}
						}
						if (targetType == "URL"){filetype="";folder = "Custom\\Atom\\Person\\Textures";}
						SuperController.singleton.GetMediaPathDialog(SelectFile, filetype,folder,false,true,false);
					});
					_displayClearFileSelectButton = CreateButton("Clear File Selection",true);	_displayClearFileSelectButton.button.onClick.AddListener(() =>{SelectFile("");});
				}
				else{		
					_displayTargetValuePopup = CreateScrollablePopup(_target1ValueChoicesJSON,true);
					if (GetCurrentActionAtom() !=null && GetCurrentActionAtom().category == "People"){_displayTargetValuePopup.popupPanelHeight = 240f;}
					else{_displayTargetValuePopup.popupPanelHeight = 360f;}
					_displayTargetValuePopup.popup.onOpenPopupHandlers += SyncTargetValueStartChoices;_displayTargetValuePopup.label = "Target Value";
				}
			}
			_spacer2 = CreateSpacer(true);_spacer2.height = 15;	_displayTestActionButton = CreateButton("Test Action",true);_displayTestActionButton.button.onClick.AddListener(() =>{TestAction();});_displayHSVRToggle = CreateToggle(_hideVAMSaveRestoreActions,true);_displayHSVRToggle.label = "Hide Save & Restore actions";
		}		
		protected List<string> GetVUMLPluginChoices(bool abbreviateContainingAtom=true){
			List<string> pluginChoices = new List<string>();
			foreach (Atom atom in SuperController.singleton.GetAtoms()) {
					foreach (string receiverName in atom.GetStorableIDs()){
						if (receiverName.Length>=4 && receiverName.Substring (receiverName.Length-4,4) =="VUML"){
							if (atom.name == containingAtom.name && abbreviateContainingAtom){pluginChoices.Add(receiverName);}
							else{pluginChoices.Add(atom.name+">"+receiverName);}
						}
					}				
			}
			if (pluginChoices.Count==0 && abbreviateContainingAtom){pluginChoices.Add("None available");}
			return (pluginChoices);
		}	
		protected void SyncTargetVUMLVar(){
			try{
				CloseAllPopup(_displayTargetVUMLVarPopup);List<string> varChoices = new List<string>();
				if (_targetValueSourceJSON.val!="Static" && _targetValueSourceJSON.val!="" && _targetValueSourceJSON.val!=null && _targetValueSourceJSON.val!="None available" && _receiver1!=null){
					JSONStorable receiver = GetPluginReceiver(_targetValueSourceJSON.val);	string targetType = GetTargetType(_target1JSON.val,_receiver1);
					if (targetType=="BOOL" || targetType=="FLOAT"|| targetType=="STRING" && receiver!=null){varChoices=GetVUMLVariableChoices(receiver,targetType);}
					if (targetType=="CHOICE" && receiver!=null){varChoices=GetVUMLVariableChoices(receiver,"STRING");}
				}
				if (varChoices.Count ==0){varChoices.Add("None");}
				_targetVUMLVariableNameJSON.choices= new List<string>();_targetVUMLVariableNameJSON.choices = varChoices;
				if(!_targetVUMLVariableNameJSON.choices.Contains(_targetVUMLVariableNameJSON.val) && !_actSwitching){_targetVUMLVariableNameJSON.val = _targetVUMLVariableNameJSON.choices[0];}
			}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SyncTargetSourceChoices(){
			try{
				CloseAllPopup(_displayTargetValueSourcePopup);List<string> tempList = new List<string>();tempList.Add("Static");tempList.AddRange(GetVUMLPluginChoices(false));	_targetValueSourceJSON.choices = new List<string>();_targetValueSourceJSON.choices = tempList;
				if(!_targetValueSourceJSON.choices.Contains(_targetValueSourceJSON.val)&& !_actSwitching){_targetValueSourceJSON.val = _targetValueSourceJSON.choices[0];}
			}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SyncWhenVUMLPluginChoices(){
			try{CloseAllPopup(_whenVUMLPluginPopup);_whenVUMLPluginJSON.choices = new List<string>();_whenVUMLPluginJSON.choices = GetVUMLPluginChoices(true);}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SyncIfVUMLPluginChoices(){
			try{CloseAllPopup(_ifVUMLPluginPopup);_ifVUMLPluginJSON.choices = new List<string>();_ifVUMLPluginJSON.choices = GetVUMLPluginChoices(true);}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected bool GetWhenBoolState(){
			bool state = false;Atom atom =null;JSONStorable receiver =null ;
			if (_whenVUMLPluginJSON.val!="None available" && _whenVUMLPluginJSON.val!=""){
				if (_whenVUMLPluginJSON.val.Length>7 && _whenVUMLPluginJSON.val.Substring(0,7) == "plugin#"){atom = containingAtom;receiver=atom.GetStorableByID(_whenVUMLPluginJSON.val);}
				else {
					String[] strlist = _whenVUMLPluginJSON.val.Split('>');atom = SuperController.singleton.GetAtomByUid(strlist[0]);
					if (atom!=null) {receiver = atom.GetStorableByID(strlist[1]);}
				}
				if (_whenVUMLVariableJSON.val!="None" && _whenVUMLVariableJSON.val!="" && receiver !=null){JSONStorableBool vBoolJSON = receiver.GetBoolJSONParam (_whenVUMLVariableJSON.val);if(vBoolJSON!=null){state = vBoolJSON.val;}else{state=_whenVBOOLStartState;}}
			}
			return (state);
		}
		protected bool GetIfBoolState(){
			bool state = false;Atom atom =null;JSONStorable receiver =null ;
			if (_ifVUMLPluginJSON.val!="None available" && _ifVUMLPluginJSON.val!=""){
				if (_ifVUMLPluginJSON.val.Length>7 && _ifVUMLPluginJSON.val.Substring(0,7) == "plugin#"){atom = containingAtom;receiver=atom.GetStorableByID(_ifVUMLPluginJSON.val);}
				else {String[] strlist = _ifVUMLPluginJSON.val.Split('>');atom = SuperController.singleton.GetAtomByUid(strlist[0]);if (atom!=null){receiver = atom.GetStorableByID(strlist[1]);}}
				if (_ifVUMLVariableJSON.val!="None" && _ifVUMLVariableJSON.val!=""&& receiver !=null){JSONStorableBool vBoolJSON = receiver.GetBoolJSONParam (_ifVUMLVariableJSON.val);if(vBoolJSON!=null){state = vBoolJSON.val;}else{state=false;}}
			}
			return (state);
		}		
		protected List<string> GetVUMLVariableChoices(JSONStorable receiver, string varType="BOOL"){
			List<string> varChoices = new List<string>();List<string> paramNames = new List<string>();
			if(receiver!=null){
				if (varType=="BOOL"){paramNames =receiver.GetBoolParamNames();}
				if (varType=="FLOAT"){paramNames =receiver.GetFloatParamNames();}
				if (varType=="STRING"){paramNames =receiver.GetStringParamNames();}		
				foreach (string targetName in paramNames){
					if (targetName.Length>varType.Length && targetName.Substring(0,varType.Length+1)=="v"+varType && targetName.Substring(targetName.Length-6,6)=="Result"){varChoices.Add(targetName);}
				}
			}
			if (varChoices.Count==0){varChoices.Add("None");}			
			return varChoices;
		}
		protected JSONStorable GetPluginReceiver (string vumlPluginName){
			Atom atom =null ;JSONStorable receiver =null ;
			if (vumlPluginName != null && vumlPluginName!="" && vumlPluginName.Length >=7 && vumlPluginName.Substring(0,7) == "plugin#"){atom = containingAtom;receiver=atom.GetStorableByID(vumlPluginName);}
			else {
				String[] strlist = vumlPluginName.Split('>');atom = SuperController.singleton.GetAtomByUid(strlist[0]);
				if (atom!=null){receiver = atom.GetStorableByID(strlist[1]);}
			}
			return (receiver);
		}
		protected void SyncWhenConditionChoices(){CloseAllPopup (_whenTriggerConditionPopup);}
		protected void SyncImportActionGrouperPlugin(){CloseAllPopup (_selectActionGrouperPluginPopup);}
		protected void SyncIfConditionChoices(){CloseAllPopup (_ifConditionPopup);}		
		protected void SyncWhenVUMLVariableChoices(){
			try{
				CloseAllPopup (_whenVUMLVariablePopup);List<string> varChoices = new List<string>();				
				if (_whenVUMLPluginJSON.val!="None available" && _whenVUMLPluginJSON.val!=""&& _targetValueSourceJSON.val!=null){
					JSONStorable receiver = GetPluginReceiver(_whenVUMLPluginJSON.val);
					if (receiver!=null){varChoices=GetVUMLVariableChoices(receiver);}
				}
				if (varChoices.Count ==0) {varChoices.Add("None");}
				_whenVUMLVariableJSON.choices = new List<string>();_whenVUMLVariableJSON.choices = varChoices;	
				if (_whenVUMLVariableJSON.val =="" || !_whenVUMLVariableJSON.choices.Contains(_whenVUMLVariableJSON.val)){_whenVUMLVariableJSON.val = _whenVUMLVariableJSON.choices[0];}
			}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}
		}			
		protected void SyncIfVUMLVariableChoices(){
			try{
				CloseAllPopup (_ifVUMLVariablePopup);	
				List<string> varChoices = new List<string>();
				if (_ifVUMLPluginJSON.val!="None available" && _ifVUMLPluginJSON.val!=""&& _targetValueSourceJSON.val!=null){
					JSONStorable receiver = GetPluginReceiver(_ifVUMLPluginJSON.val);
					if (receiver!=null){varChoices=GetVUMLVariableChoices(receiver);}
				}
				if (varChoices.Count ==0) {varChoices.Add("None");}
				_ifVUMLVariableJSON.choices= new List<string>();	_ifVUMLVariableJSON.choices = varChoices;	
			}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SyncActChoices(){try{CloseAllPopup(_displayActPopup);}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}}
        protected void SyncAtom1Choices(){try{CloseAllPopup(_displayAtomPopup);_atom1JSON.choices= new List<string>();_atom1JSON.choices = GetAtomListChoices ();}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}}
        protected List<string> GetAtomListChoices(){
            List<string> atomChoices = new List<string>();
            foreach (string atomUID in SuperController.singleton.GetAtomUIDs()){atomChoices.Add(atomUID);}
			return atomChoices;
		}
        protected void SyncAtomX(string actionRef, string atomUID, JSONStorableStringChooser atomChooser){
			if (atomUID == null){atomUID="";}
			if (actionRef=="1"){SyncAtom1Choices();}
			_atom1JSON.choices= new List<string>();_atom1JSON.choices = GetAtomListChoices ();
			if (!_actSwitching && (atomUID == "" || !atomChooser.choices.Contains(atomUID))){atomChooser.val = atomChooser.choices[0];atomUID = atomChooser.val;}
		}
        protected void SyncAtom1(string atomUID){
			try{
				SyncAtomX ("1", atomUID, _atom1JSON);CreateReceiverUI() ;SyncReceiverGroup1Choices();SyncReceiver1Choices();
				if (!_actSwitching && GetCurrentActionAtom() !=null){
					GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._atomNameActStart.val = atomUID;
					string atomCategory = GetCurrentActionAtom().category ;
					if (atomCategory == "Animation"){_receiver1JSON.val="AnimationPattern";}
					if (atomCategory == "Sound"){_receiver1JSON.val="AudioSource";}
					if (atomCategory == "Force"){_receiver1JSON.val="ForceProducer";}
					if (atomCategory == "Light"){_receiver1JSON.val="Light";}
					if (atomCategory == "Reflective"){_receiver1JSON.val="MirrorRender";}
					if (atomCategory == "Triggers"){_receiver1JSON.val="Trigger";}		
				}
			}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}
        }
        protected void SyncReceiverXChoices(string atomUID, JSONStorableStringChooser receiverChooser){
			List<string> choices = new List<string>();choices = GetActionReceiverListChoices (atomUID);
			if (receiverChooser != null){receiverChooser.choices= new List<string>();receiverChooser.choices = choices;		
				if (!receiverChooser.choices.Contains(receiverChooser.val) && !_actSwitching){receiverChooser.val = receiverChooser.choices[0];}
			}
		}
		protected List<string> GetActionReceiverListChoices(string atomUID){
			List<string> receiverChoices = new List<string>();Atom atom = SuperController.singleton.GetAtomByUid(atomUID);
			if (atom==null){SuperController.LogMessage("Atom is null in GetActionReceiverListChoices: "+atomUID);}
            else {
				int minActions =0 ;
				if (_hideVAMSaveRestoreActions.val == true)	{minActions = 15;}else{minActions =0;}		
				if ((_receiverGroup1JSON.val == "Clothing" || _receiverGroup1JSON.val == "Hair" || _receiverGroup1JSON.val == "Physics" ) && GetCurrentActionAtom() !=null && GetCurrentActionAtom().category == "People") {receiverChoices.Add("geometry");}
				if (_receiverGroup1JSON.val == "Other"  && GetCurrentActionAtom() !=null && GetCurrentActionAtom().category == "People"){receiverChoices.Add("Load Look/Pose/Preset");receiverChoices.Add("Dress/Undress Clothing");}
				foreach (string receiverChoice in atom.GetStorableIDs()){
					if( atom.GetStorableByID(receiverChoice)?.GetActionNames()?.Count > minActions ||atom.GetStorableByID(receiverChoice)?.GetBoolParamNames()?.Count > 0 ||atom.GetStorableByID(receiverChoice)?.GetStringChooserParamNames()?.Count > 0 ||atom.GetStorableByID(receiverChoice)?.GetFloatParamNames()?.Count > 0 ||atom.GetStorableByID(receiverChoice)?.GetColorParamNames()?.Count > 0){
						if (GetCurrentActionAtom() !=null && GetCurrentActionAtom().category != "People"){receiverChoices.Add(receiverChoice);}
						else {
							if (receiverChoice.Contains("Preset")){if (_receiverGroup1JSON.val == "Presets") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("plugin#")){if (_receiverGroup1JSON.val == "Plugins") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("Trigger")){if (_receiverGroup1JSON.val == "Collision Triggers") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("Animation") || receiverChoice.Contains("animation")){if (_receiverGroup1JSON.val == "Node Animations") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("Hair") || receiverChoice.Contains("Ponytail")|| receiverChoice.Contains("hair")){if (_receiverGroup1JSON.val == "Hair") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("Wrap") || receiverChoice.Contains("Sim") || receiverChoice.Contains("Style") || receiverChoice.Contains("Material") || receiverChoice.Contains("Item") || receiverChoice.Contains("Clothing")){if (_receiverGroup1JSON.val == "Clothing") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("BreastPhysicsMesh") || receiverChoice.Contains("LowerPhysicsMesh")|| receiverChoice.Contains("control")|| receiverChoice.Contains("rescaleObject") || receiverChoice.Contains("Physics")){if (_receiverGroup1JSON.val == "Physics") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("Control")){if (_receiverGroup1JSON.val == "Node Controls") {receiverChoices.Add(receiverChoice);}}
							else if (receiverChoice.Contains("Eye") || receiverChoice.Contains("sclera")|| receiverChoice.Contains("irises")|| receiverChoice.Contains("skin")|| receiverChoice.Contains("textures")|| receiverChoice.Contains("Skin")|| receiverChoice.Contains("lacrimal")|| receiverChoice.Contains("mouth")|| receiverChoice.Contains("teeth")|| receiverChoice.Contains("tongue")|| receiverChoice.Contains("Anatomy")){if (_receiverGroup1JSON.val == "Skin & Eyes") {receiverChoices.Add(receiverChoice);}}
							else{if (_receiverGroup1JSON.val == "Other") {receiverChoices.Add(receiverChoice);}}
						}
					}
				}
			}
			return receiverChoices ;
		}
        protected void SyncReceiver1Choices(){CloseAllPopup(_displayReceiverPopup);SyncReceiverXChoices (_atom1JSON.val, _receiver1JSON);}
        protected void SyncReceiverX(string actionRef, string receiverID , Atom atom, JSONStorableStringChooser receiverChooser){
			if (receiverID == null){receiverID="";}
			SyncReceiverXChoices(atom.name,receiverChooser);			
			if ((receiverID == "" || !receiverChooser.choices.Contains(receiverID)) && !_actSwitching){receiverChooser.val = receiverChooser.choices[0];receiverID = receiverChooser.val;}			
			if (actionRef=="1"){_receiver1 = atom.GetStorableByID(receiverID);}
		}
        protected void SyncReceiver1(string receiverID){			
			if (GetCurrentActionAtom() !=null){SyncReceiverX ("1",receiverID, GetCurrentActionAtom(), _receiver1JSON);SyncTarget1Choices ();}
			if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._receiverNameActStart.val = receiverID;}
		}	
        protected void SyncReceiverGroup1(string receiverGroupID){
			SyncReceiver1Choices();
			if (_receiver1JSON.val =="geometry"){SyncTarget1Choices();}
			if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._receiverGroupNameActStart.val = receiverGroupID;}
		}
        protected void SyncReceiverGroup1Choices(){
			List<string> receiverGroupChoices = new List<string>();CloseAllPopup(_displayReceiverGroupPopup);
			receiverGroupChoices.Add("Node Controls");receiverGroupChoices.Add("Node Animations");receiverGroupChoices.Add("Collision Triggers");receiverGroupChoices.Add("Hair");receiverGroupChoices.Add("Clothing");receiverGroupChoices.Add("Skin & Eyes");
			if (GetCurrentActionAtom() !=null){List<string> receivers = GetCurrentActionAtom().GetStorableIDs ();int countPlugins = 0;
				foreach (string receiver in receivers) {if (receiver.Contains("plugin#")){countPlugins++;}}
				if (countPlugins>0){receiverGroupChoices.Add("Plugins");}
			}
			receiverGroupChoices.Add("Physics");receiverGroupChoices.Add("Presets");receiverGroupChoices.Add("Other");_receiverGroup1JSON.choices= new List<string>();_receiverGroup1JSON.choices = receiverGroupChoices;
			if (!_receiverGroup1JSON.choices.Contains(_receiverGroup1JSON.val) && !_actSwitching){_receiverGroup1JSON.val = _receiverGroup1JSON.choices[0];}			
		}
        protected void SyncTargetXChoices(JSONStorableStringChooser targetChooser, string atomUID, JSONStorable receiver, bool noActionOption, bool noAudioClipActions) {
			List<string> choices = new List<string>();
			if(_receiver1JSON.val == "Load Look/Pose/Preset"){
				choices.Add("Load Clothing Preset");choices.Add("Merge Clothing Preset");choices.Add("Remove Clothing Preset");choices.Add("Reset Sim Cloth Preset");choices.Add("Sim Undress Cloth Preset");choices.Add("Sim Dress Cloth Preset");choices.Add("Load App Preset");choices.Add("Load Pose Preset");choices.Add("Load Hair Preset");choices.Add("Load Morph Preset");choices.Add("Load Skin Preset");choices.Add("Load Breast Preset");choices.Add("Load Glute Preset");choices.Add("Load General Preset");choices.Add("Load Look");choices.Add("Load Pose");choices.Add("Load Preset");				
			}
			else if(_receiver1JSON.val == "Dress/Undress Clothing"){choices.Add("Undress All Clothing");choices.Add("Dress All Clothing");choices.Add("Reset Sim All Clothing");choices.Add("Remove All Clothing");}
			else{choices = GetActionTargetListChoices (atomUID, receiver, noActionOption,noAudioClipActions);}
			if (targetChooser != null){targetChooser.choices = new List<string>();targetChooser.choices = choices;
				if (!targetChooser.choices.Contains(targetChooser.val) && !_actSwitching){targetChooser.val = targetChooser.choices[0];	}
			}
		}
        protected void SyncTarget1Choices(){try{SyncTargetXChoices (_target1JSON, _atom1JSON.val, _receiver1,false,false);CloseAllPopup(_displayTargetPopup);}catch(Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected List<string> GetActionTargetListChoices(string atomUID, JSONStorable receiver, bool noActionOption, bool noAudioClipActions){
            List<string> targetChoices = new List<string>();List<string> actionChoices = new List<string>();List<string> audioChoices = new List<string>(); List<string> boolChoices = new List<string>(); List<string> stringChooserChoices = new List<string>(); List<string> floatChoices = new List<string>();List<string> colorChoices = new List<string>();List<string> urlChoices = new List<string>();List<string> stringChoices = new List<string>();List<string> tempChoices = new List<string>();List<string> temp2Choices = new List<string>();bool isVUMLPlugin = false;
			boolChoices = receiver.GetBoolParamNames ();floatChoices = receiver.GetFloatParamNames ();colorChoices = receiver.GetColorParamNames ();stringChooserChoices = receiver.GetStringChooserParamNames ();audioChoices = receiver.GetAudioClipActionNames();urlChoices = receiver.GetUrlParamNames ();stringChoices = receiver.GetStringParamNames (); actionChoices = receiver.GetActionNames ();				
			if (noActionOption){targetChoices.Add ("NO ACTION");}
			if (!noAudioClipActions){foreach (string choice in audioChoices){targetChoices.Add(choice);}}
			foreach (string choice in actionChoices){
				if (!_hideVAMSaveRestoreActions.val ||(choice != "SaveToStore1" && choice != "SaveToStore2" && choice != "SaveToStore3" && choice != "RestoreAllFromStore1" && choice != "RestoreAllFromStore2" && choice != "RestoreAllFromStore3" && choice != "RestorePhysicsFromStore1" && choice != "RestorePhysicsFromStore2" && choice != "RestorePhysicsFromStore3" && choice != "RestoreAppearanceFromStore1" &&	 choice != "RestoreAppearanceFromStore2" && choice != "RestoreAppearanceFromStore3" && choice != "RestoreAllFromDefaults" && choice != "RestorePhysicalFromDefaults" &&	 choice != "RestoreAppearanceFromDefaults" )){if(AddTargetChoices (choice)){targetChoices.Add(choice);}}
			}
			if (receiver.storeId.Length>=4 && receiver.storeId.Substring (receiver.storeId.Length-4,4) =="VUML"){isVUMLPlugin=true;}
			foreach (string choice in boolChoices){
				if(AddTargetChoices (choice)){
					if(choice.Length>=6 && choice.Substring(choice.Length-6,6)=="Result"){tempChoices.Add(choice);}
					else{temp2Choices.Add(choice);}
				}
			}
			foreach (string choice in stringChooserChoices){
				if(AddTargetChoices (choice)){
					if(choice.Length>=6 && choice.Substring(choice.Length-6,6)=="Result"){tempChoices.Add(choice);}
					else{temp2Choices.Add(choice);}
				}
			}
			foreach (string choice in floatChoices){
				if(AddTargetChoices (choice)){
					if(choice.Length>=6 && choice.Substring(choice.Length-6,6)=="Result"){tempChoices.Add(choice);}
					else{temp2Choices.Add(choice);}
				}
			}
			foreach (string choice in tempChoices){targetChoices.Add(choice);}
			foreach (string choice in colorChoices){if(AddTargetChoices (choice)){temp2Choices.Add(choice);}}
			foreach (string choice in urlChoices){if(AddTargetChoices (choice)){temp2Choices.Add(choice);}}
			foreach (string choice in stringChoices){if(AddTargetChoices (choice)){temp2Choices.Add(choice);}}		
			temp2Choices.Sort();
			foreach (string choice in temp2Choices){targetChoices.Add(choice);}
			if (targetChoices.Count==0){targetChoices.Add("None");}
			return targetChoices;
		}
		protected bool AddTargetChoices (string choice) {
			Atom atom = GetCurrentActionAtom();
			if (atom !=null){
				if (GetCurrentActionAtom().category == "People" && _receiverGroup1JSON.val == "Clothing" && _receiver1JSON.val == "geometry"){
					if (choice.Contains("clothing:")|| choice.Contains("toggle:")){return(true);}}
				else if (GetCurrentActionAtom().category == "People" && _receiverGroup1JSON.val == "Hair" && _receiver1JSON.val == "geometry"){
					if (choice.Contains("hair")){return(true);}}
				else if (GetCurrentActionAtom().category == "People" && _receiverGroup1JSON.val == "Physics" && _receiver1JSON.val == "geometry"){
					if (choice.Contains("Colliders")){return(true);}}
				else if (GetCurrentActionAtom().category == "People" && _receiverGroup1JSON.val == "Other" && _receiver1JSON.val == "geometry"){
					if (!choice.Contains("clothing:")&& !choice.Contains("toggle:")&& !choice.Contains("Colliders")&& !choice.Contains("hair")){return(true);}	}
				else { return(true);}
			}
			return (false);
		}
		protected string GetTargetType(string targetID, JSONStorable receiver){
			string targetType = "";	string receiverName = "" ;				
			if (targetID == "Load Look"){targetType = "LOADLOOK";}else if (targetID == "Load Pose"){targetType = "LOADPOSE";}else if (targetID == "Load Clothing Preset"){targetType = "LOADCLOTHPRESET";}else if (targetID == "Merge Clothing Preset"){targetType = "LOADCLOTHPRESET";}else if (targetID == "Remove Clothing Preset"){targetType = "LOADCLOTHPRESET";}else if (targetID == "Reset Sim Cloth Preset"){targetType = "LOADCLOTHPRESET";}else if (targetID == "Sim Dress Cloth Preset"){targetType = "LOADCLOTHPRESET";}else if (targetID == "Sim Undress Cloth Preset"){targetType = "LOADCLOTHPRESET";}else if (targetID == "Load App Preset"){targetType = "LOADAPPPRESET";}else if (targetID == "Load General Preset"){targetType = "LOADGENPRESET";}else if (targetID == "Load Hair Preset"){targetType = "LOADHAIRPRESET";}else if (targetID == "Load Morph Preset"){targetType = "LOADMORPHPRESET";}else if (targetID == "Load Breast Preset"){targetType = "LOADBREASTPRESET";}else if (targetID == "Load Glute Preset"){targetType = "LOADGLUTEPRESET";}else if (targetID == "Load Skin Preset"){targetType = "LOADSKINPRESET";}else if (targetID == "Load Pose Preset"){targetType = "LOADPOSEPRESET";}else if (targetID == "Undress All Clothing"){targetType = "UNDRESS";}else if (targetID == "Dress All Clothing"){targetType = "UNDRESS";}else if (targetID == "Reset Sim All Clothing"){targetType = "UNDRESS";}else if (targetID == "Remove All Clothing"){targetType = "UNDRESS";}
			else if (receiver != null){
				receiverName = receiver.storeId ;
				if (receiver.IsBoolJSONParam(targetID) ){targetType = "BOOL";}else if (receiver.IsStringChooserJSONParam(targetID)){targetType = "CHOICE";}else if (receiver.IsFloatJSONParam(targetID)){targetType = "FLOAT";}else if (receiver.IsAudioClipAction(targetID)){targetType = "AUDIO";}else if (receiver.IsAction(targetID)){targetType = "ACTION";}else if (receiver.IsColorJSONParam(targetID)){targetType = "COLOR";}else if (receiver.IsUrlJSONParam(targetID)){targetType = "URL";}else if (receiver.IsStringJSONParam(targetID)){targetType = "STRING";}else {targetType = "OTHER";}
			}
			return targetType;	
		}	
        protected void TargetValueSourceSelect(string targetSource){if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._targetValueSource.val = targetSource;}SyncTargetVUMLVar();CreateTargetUI();}
        protected void TargetVUMLVarSelect(string targetID){if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._targetVUMLVariableName.val = targetID;}}
        protected void Target1Select(string targetID){try{
			if (!_actSwitching && (_receiver1!=null || _receiver1JSON.val == "Load Look/Pose/Preset" || _receiver1JSON.val == "Dress/Undress Clothing")){
				GroupAction groupAct; String lastActionType ;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._targetNameActStart.val = targetID;lastActionType = groupAct._actionTypeStart.val;groupAct._actionTypeStart.val = GetTargetType(targetID,_receiver1);Atom atom; JSONStorable receiver;atom = SuperController.singleton.GetAtomByUid(_atom1JSON.val);
				if (atom!=null){
					receiver = atom.GetStorableByID(_receiver1JSON.val);
					if (receiver !=null){
						if (groupAct._actionTypeStart.val=="BOOL"){JSONStorableBool actionBoolJSON = receiver.GetBoolJSONParam(targetID) ;
							if(actionBoolJSON.val){_target1ValueChoicesJSON.val = "TRUE";}else{_target1ValueChoicesJSON.val = "FALSE";}
						}
						else if (groupAct._actionTypeStart.val=="CHOICE"){JSONStorableStringChooser actionStringChoiceJSON = receiver.GetStringChooserJSONParam(targetID) ;_target1ValueChoicesJSON.val = actionStringChoiceJSON.val;}
						else if (groupAct._actionTypeStart.val=="FLOAT"){JSONStorableFloat actionFloatJSON = receiver.GetFloatJSONParam(targetID) ;_target1ValueFloatJSON.val = actionFloatJSON.val;}
						else if (groupAct._actionTypeStart.val=="COLOR"){JSONStorableColor actionColorJSON = receiver.GetColorJSONParam(targetID) ;_target1ValueColorJSON.val = actionColorJSON.val;}
						else if (groupAct._actionTypeStart.val=="URL"){JSONStorableUrl actionUrlJSON = receiver.GetUrlJSONParam(targetID) ;_target1ValueFilePathStringJSON.val = actionUrlJSON.val;	}
						else if (groupAct._actionTypeStart.val=="STRING"){JSONStorableString actionStringJSON = receiver.GetStringJSONParam(targetID) ;_target1ValueChoicesJSON.val = actionStringJSON.val;	}
						else {if (lastActionType!=groupAct._actionTypeStart.val){_target1ValueFilePathStringJSON.val ="";Target1FileURLValueSelect ("");}}
					}
				}					
			}
			SyncTargetValueStartChoices ();SyncTargetVUMLVar();CreateReceiverUI() ;
        }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }}
		protected void Target1FloatSelect (float targetValue){if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._targetFloatValueStart.val = targetValue;}	}
		protected void Target1ColorSelect (JSONStorableColor jc){if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._targetColorValueStart.val = jc.val;}}
		protected void Target1ValueSelect (string targetValue){if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._targetValueStart.val = targetValue;}}
		protected void Target1FileURLValueSelect (string targetValue){if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._targetFileURLValueStart.val = targetValue;}}
		protected List<string> GetAudioClipChoices(bool includeEmbedded){
            List<string> audioClipChoices = new List<string>();List<string> audioClipCategories = new List<string>();
			if (URLAudioClipManager.singleton.GetCategories().Count >0){
				foreach (string clip in URLAudioClipManager.singleton.GetCategoryClips("web").Select((clip) => clip.uid).ToList()){audioClipChoices.Add (clip);}}
			if (includeEmbedded){
				audioClipCategories = EmbeddedAudioClipManager.singleton.GetCategories();			
				foreach (string category in audioClipCategories){
					foreach (string clip in EmbeddedAudioClipManager.singleton.GetCategoryClips(category).Select((clip) => clip.uid).ToList()){audioClipChoices.Add (clip+":"+category);}
				}
			}				
            return audioClipChoices;
		}
		protected void SyncTargetValueStartChoices (){
			CloseAllPopup(_displayTargetValuePopup);List<String> targetOptionsChoices = new List<String>();GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;
			if (groupAct._actionTypeStart.val == "AUDIO"){targetOptionsChoices = GetAudioClipChoices (true);}
			else if (groupAct._actionTypeStart.val == "BOOL"){targetOptionsChoices.Add ("TRUE"); targetOptionsChoices.Add ("FALSE");}
			else if (groupAct._actionTypeStart.val == "CHOICE" && _receiver1!=null){
				JSONStorableStringChooser targetStringChooserJSON = _receiver1.GetStringChooserJSONParam(_target1JSON.val);
				if (targetStringChooserJSON.choices!=null){foreach (string choice in targetStringChooserJSON.choices) {targetOptionsChoices.Add(choice);}}
				if (targetOptionsChoices.Count==0){targetOptionsChoices.Add(targetStringChooserJSON.val);}
			}
			else { targetOptionsChoices.Add("n/a");}				
			_target1ValueChoicesJSON.choices= new List<string>();_target1ValueChoicesJSON.choices = targetOptionsChoices ;				
			if (!_target1ValueChoicesJSON.choices.Contains(_target1ValueChoicesJSON.val) && !_actSwitching){_target1ValueChoicesJSON.val = _target1ValueChoicesJSON.choices[0];}
		}
       protected void SyncProb(float probability){
			if (probability < 0f){probability = 0f;_probabilityWeight.val = 0f;}
			if (!_actSwitching){GroupAction groupAct;_randomActDict.TryGetValue(_currentActionChooser.val, out groupAct) ;groupAct._actProbability.val = probability;}
        }
        protected void SwitchAction(string actID){try{
			GroupAction groupAct;_randomActDict.TryGetValue(actID, out groupAct) ;_actSwitching =true;
			if(_atom1JSON != null){
				_atom1JSON.val = groupAct._atomNameActStart.val;_receiverGroup1JSON.val = groupAct._receiverGroupNameActStart.val;_receiver1JSON.val = groupAct._receiverNameActStart.val;_target1JSON.val = groupAct._targetNameActStart.val ;_target1ValueChoicesJSON.val = groupAct._targetValueStart.val ;_targetValueSourceJSON.val = groupAct._targetValueSource.val ;
				_targetVUMLVariableNameJSON.val = groupAct._targetVUMLVariableName.val ;_target1ValueFloatJSON.val = groupAct._targetFloatValueStart.val ;_target1ValueColorJSON.val = groupAct._targetColorValueStart.val ;_probabilityWeight.val = groupAct._actProbability.val ; _target1ValueFilePathStringJSON.val = groupAct._targetFileURLValueStart.val;
			}
			_actSwitching =false;CreateReceiverUI() ;
			}catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
		}
		protected void RegisterGAParams(GroupAction grpAction){
			RegisterString(grpAction._atomNameActStart);RegisterString(grpAction._receiverGroupNameActStart);RegisterString(grpAction._receiverNameActStart);RegisterString(grpAction._targetNameActStart);RegisterString(grpAction._targetValueStart);RegisterString(grpAction._targetValueSource);RegisterString(grpAction._targetVUMLVariableName);RegisterString(grpAction._actionTypeStart);RegisterFloat(grpAction._actProbability);	RegisterFloat(grpAction._targetFloatValueStart);RegisterColor(grpAction._targetColorValueStart);RegisterString(grpAction._targetFileURLValueStart);
		}
		protected string CreateNextAct(){
			_actCount = _actCount + 1;GroupAction newAct = new GroupAction (_actCount,"CoreControl");RegisterGAParams (newAct);_randomActList.Add(newAct);	string newActName = "Action "+_actCount.ToString();_randomActDict [newActName] = newAct;return newActName ;
		}

		protected int GetActionCount(JSONNode varSaveJSON){
			int count=0;
			foreach (KeyValuePair<string, JSONNode> kvp in (JSONClass)varSaveJSON){
				if (kvp.Key.Length>9){if (kvp.Key.Substring(kvp.Key.Length-9,9)=="Atom1Name"){int varID = 0;if (kvp.Key.Substring(0,3)=="act"){Int32.TryParse(kvp.Key.Substring(3,kvp.Key.Length-3-9), out varID);count =Math.Max(varID,count);}}}
			}
			return (count);			
		}
		public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true)
        {
            
            try
            {
                base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms, setMissingToDefault);
				LoadActions(jc);
            }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }

        }
		protected void LoadActions (JSONNode savedJson, bool import=false){
			int startIndex = 0;int skipped = 0;int actionCount = 0;if (savedJson!=null){actionCount=GetActionCount(savedJson);}
			if (import){startIndex=_actCount;}	
			for (int i = 0; i < actionCount; i++){
				int actIndex = i+1;string atomName = savedJson["act"+((actIndex).ToString())+"Atom1Name"];string receiverName = savedJson["act"+((actIndex).ToString())+"Receiver1Name"];
				if (SuperController.singleton.GetAtomUIDs().Contains(atomName) || !import){
					if (SuperController.singleton.GetAtomByUid(atomName).GetStorableIDs().Contains(receiverName)|| !import){
						GroupAction newAct = new GroupAction (startIndex+actIndex-skipped,"CoreControl");RegisterGAParams (newAct);newAct._atomNameActStart.val = savedJson["act"+((actIndex).ToString())+"Atom1Name"];newAct._receiverGroupNameActStart.val = savedJson["act"+((actIndex).ToString())+"ReceiverGroup1Name"];newAct._receiverNameActStart.val = savedJson["act"+((actIndex).ToString())+"Receiver1Name"];newAct._targetNameActStart.val = savedJson["act"+((actIndex).ToString())+"Target1Name"];newAct._targetValueStart.val = savedJson["act"+((actIndex).ToString())+"Target1ValueName"];newAct._targetValueSource.val = savedJson["act"+((actIndex).ToString())+"Target1ValueSource"];newAct._targetVUMLVariableName.val = savedJson["act"+((actIndex).ToString())+"Target1VUMLVarName"];newAct._targetFloatValueStart.val = savedJson["act"+((actIndex).ToString())+"Target1FloatValueName"].AsFloat;HSVColor color ;if (savedJson["act"+((actIndex).ToString())+"Target1ColorValueName"]["h"]!=null){color.H = savedJson["act"+((actIndex).ToString())+"Target1ColorValueName"]["h"].AsFloat;}else{color.H =0f;}if (savedJson["act"+((actIndex).ToString())+"Target1ColorValueName"]["s"]!=null){color.S = savedJson["act"+((actIndex).ToString())+"Target1ColorValueName"]["s"].AsFloat;}else{color.S =0f;}if (savedJson["act"+((actIndex).ToString())+"Target1ColorValueName"]["v"]!=null){color.V = savedJson["act"+((actIndex).ToString())+"Target1ColorValueName"]["v"].AsFloat;}else{color.V =0f;}newAct._targetColorValueStart.val = color; newAct._targetFileURLValueStart.val = savedJson["act"+((actIndex).ToString())+"Target1UrlValueName"];newAct._actionTypeStart.val = savedJson["act"+((actIndex).ToString())+"Action1TypeName"];newAct._actProbability.val = savedJson["act"+((actIndex).ToString())+"Probability"].AsFloat;
						if (newAct._targetValueSource.val == null || newAct._targetValueSource.val == ""){newAct._targetValueSource.val="Static";}
						if (newAct._targetVUMLVariableName.val == null || newAct._targetVUMLVariableName.val == ""){newAct._targetVUMLVariableName.val="None";}
						_randomActList.Add(newAct);	string newActName = "Action "+((startIndex+actIndex-skipped).ToString());_randomActDict [newActName] = newAct;
					}
					else {skipped++; SuperController.LogMessage("Load of Act "+actIndex.ToString()+" failed. Receiver '"+receiverName+"' does not exist in the Atom '"+atomName+"'."); }
				}
				else {skipped++; SuperController.LogMessage("Load of Act "+actIndex.ToString()+" failed. Atom '"+atomName+"' does not exist in this scene."); }
			}
			if (import){_actCount=_actCount+actionCount-skipped;}else {_actCount = actionCount;}
		}
		protected bool PlayActDecision(float probability){bool play = true;float randNumb = UnityEngine.Random.Range (0f, 1f);if (randNumb >= probability ){play = false;}if (probability >= 1f) {play =true;}return play;}
		protected void PlayAction(string actionType, Atom atom, JSONStorable receiver, string targetName, string targetValue, float targetFloatValue, HSVColor targetColorValue, string targetUrlValue, string targetVUMLPlugin="Static",string targetVUMLVar="None" ){
			JSONStorable pluginReceiver = null;
			if (targetVUMLPlugin!="Static" && targetVUMLPlugin!="" && targetVUMLPlugin!=null){pluginReceiver=GetPluginReceiver(targetVUMLPlugin);}
			if(actionType == "ACTION"){receiver.CallAction (targetName);}
			else if(actionType == "AUDIO"){
				AudioSourceControl source = receiver as AudioSourceControl;
				NamedAudioClip clip = GetAudioClip(targetValue);
				if (clip == null) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load Audio Clip ("+targetValue+")");}
				else{
					if (targetName == "PlayNow"){source.PlayNow(clip);}
					if (targetName == "PlayIfClear"){source.PlayIfClear(clip);}
					if (targetName == "PlayNowLoop"){source.PlayNowLoop(clip);}
					if (targetName == "PlayNowClearQueue"){source.PlayNowClearQueue(clip);}
					if (targetName == "PlayNext"){source.PlayNext(clip);}
					if (targetName == "PlayNextClearQueue"){source.PlayNextClearQueue(clip);}
					if (targetName == "Queue"){source.QueueClip(clip);}
				}
			}
			else if(actionType == "BOOL"){
				JSONStorableBool actionBoolJSON = receiver.GetBoolJSONParam(targetName) ;
				if (actionBoolJSON == null) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load target ("+targetName+")");}
				else if (targetVUMLPlugin=="Static"){
					if(targetValue == "TRUE"){actionBoolJSON.val = true;}
					else{actionBoolJSON.val = false;}
				}
				else if (targetVUMLVar!="None" && pluginReceiver!=null && pluginReceiver.IsBoolJSONParam(targetVUMLVar)) {actionBoolJSON.val = pluginReceiver.GetBoolJSONParam(targetVUMLVar).val;}
			}
			else if (actionType == "CHOICE" ){
				JSONStorableStringChooser actionStringChoiceJSON = receiver.GetStringChooserJSONParam(targetName) ;
				if (actionStringChoiceJSON == null) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load target ("+targetName+")");}
				else if (targetVUMLPlugin=="Static"){actionStringChoiceJSON.val = targetValue;}
				else if (targetVUMLVar!="None"&& pluginReceiver!=null && pluginReceiver.IsStringJSONParam(targetVUMLVar)) {actionStringChoiceJSON.val = pluginReceiver.GetStringJSONParam(targetVUMLVar).val;}
			}	
			else if (actionType == "COLOR"){
				JSONStorableColor actionColorChoiceJSON = receiver.GetColorJSONParam(targetName) ;
				if (actionColorChoiceJSON == null) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load target ("+targetName+")");}
				else {actionColorChoiceJSON.val = targetColorValue;}
			}	
			else if (actionType == "FLOAT"){
				JSONStorableFloat actionFloatValueJSON = receiver.GetFloatJSONParam(targetName) ;
				if (actionFloatValueJSON == null) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load target ("+targetName+")");}
				else if (targetVUMLPlugin=="Static"){actionFloatValueJSON.val = targetFloatValue;}
				else if (targetVUMLVar!="None"&& pluginReceiver!=null && pluginReceiver.IsFloatJSONParam(targetVUMLVar)) {actionFloatValueJSON.val = pluginReceiver.GetFloatJSONParam(targetVUMLVar).val;}
			}
			else if (actionType == "URL"){
				JSONStorableUrl actionUrlValueJSON = receiver.GetUrlJSONParam(targetName) ;
				if (actionUrlValueJSON == null) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load target ("+targetName+")");}
				else {
					try{actionUrlValueJSON.val = targetUrlValue;}
					catch (Exception e) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load target ("+targetName+") due to the  invalid filename '"+targetUrlValue+"'");}
				}
			}
			else if (actionType == "STRING"){
				JSONStorableString actionStringValueJSON = receiver.GetStringJSONParam(targetName) ;
				if (actionStringValueJSON == null) {SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load target ("+targetName+")");}
				else if (targetVUMLPlugin=="Static"){actionStringValueJSON.val = targetUrlValue;}
				else if (targetVUMLVar!="None"&& pluginReceiver!=null && pluginReceiver.IsStringJSONParam(targetVUMLVar)) {actionStringValueJSON.val = pluginReceiver.GetStringJSONParam(targetVUMLVar).val;}
			}
			else if (actionType == "LOADLOOK"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){atom.LoadAppearancePreset(_vamFilePath+targetUrlValue);}}
			else if (actionType == "LOADPOSE"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){atom.LoadPhysicalPreset(_vamFilePath+targetUrlValue);}}
			else if (actionType == "LOADPRESET"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){atom.LoadPreset(_vamFilePath+targetUrlValue);}}
			else if (actionType == "UNDRESS"){DressActions(atom,targetName);}
			else if (targetName == "Merge Clothing Preset"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){MergePreset (atom, _vamFilePath+targetUrlValue);}}
			else if (targetName == "Remove Clothing Preset"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){MergePreset (atom, _vamFilePath+targetUrlValue, true);}}
			else if (targetName == "Reset Sim Cloth Preset"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){MergePreset (atom, _vamFilePath+targetUrlValue, false,"RESETSIM");}}
			else if (targetName == "Sim Undress Cloth Preset"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){MergePreset (atom, _vamFilePath+targetUrlValue, false,"UNDRESS");}}
			else if (targetName == "Sim Dress Cloth Preset"){if(targetUrlValue!=""&&targetUrlValue!="n/a"){MergePreset (atom, _vamFilePath+targetUrlValue, true,"UNDRESS");}}
			else {
				JSONStorable js = null;
				if (actionType == "LOADCLOTHPRESET"){js = atom.GetStorableByID("ClothingPresets");}
				if (actionType == "LOADAPPPRESET"){js = atom.GetStorableByID("AppearancePresets");}
				if (actionType == "LOADGENPRESET"){js = atom.GetStorableByID("Preset");}
				if (actionType == "LOADHAIRPRESET"){js = atom.GetStorableByID("HairPresets");}
				if (actionType == "LOADMORPHPRESET"){js = atom.GetStorableByID("MorphPresets");}
				if (actionType == "LOADPOSEPRESET"){js = atom.GetStorableByID("PosePresets");}
				if (actionType == "LOADBREASTPRESET"){js = atom.GetStorableByID("FemaleBreastPhysicsPresets");if(atom==null){js = atom.GetStorableByID("MaleBreastPhysicsPresets");}}
				if (actionType == "LOADGLUTEPRESET"){js = atom.GetStorableByID("FemaleGlutePhysicsPresets");if(atom==null){js = atom.GetStorableByID("MaleGlutePhysicsPresets");}}
				if (actionType == "LOADSKINPRESET"){js = atom.GetStorableByID("SkinPresets");}			
				if (js!=null && targetUrlValue!=""){JSONStorableUrl presetPathJSON = js.GetUrlJSONParam("presetBrowsePath");if(presetPathJSON!=null){presetPathJSON.val = SuperController.singleton.NormalizePath(targetUrlValue);}js.CallAction("LoadPreset");}
			}
		}	
		protected void DressActions( Atom atom, string actionMode){
			foreach (string receiverName in atom.GetStorableIDs()){
				JSONStorable receiver = atom.GetStorableByID(receiverName);
				if(receiver!=null){				
					if (receiver.storeId.Length>=3 && receiver.storeId.Substring(receiver.storeId.Length - 3) =="Sim"){
						JSONStorableBool unDressBool = receiver.GetBoolJSONParam("allowDetach");JSONStorableBool simEnabledBool = receiver.GetBoolJSONParam("simEnabled");
						if (actionMode =="Dress All Clothing" && unDressBool!=null){unDressBool.val = false;}
						if (actionMode =="Undress All Clothing"&& unDressBool!=null){unDressBool.val = true;}
						if (actionMode =="Reset Sim All Clothing"&& simEnabledBool!=null){if(simEnabledBool.val){receiver.CallAction("Reset");}}
					}
					if (receiver.storeId=="geometry" && actionMode =="Remove All Clothing"){
						foreach (string target in receiver.GetBoolParamNames()){if(target.Length>8){if (target.Substring(0,9)=="clothing:"){JSONStorableBool boolTarget = receiver.GetBoolJSONParam(target);if (boolTarget!=null){boolTarget.val=false;}}}}
					}
				}
			}
		}	
		protected void MergePreset( Atom atom, string fileName, bool reverse = false, string specialMode = "NONE"){
			JSONNode presetJSON = this.LoadJSON(fileName);JSONArray storablesJSON=presetJSON["storables"].AsArray ;
			for (int index = 0; index < storablesJSON.Count; index++){
				if ((string)storablesJSON[index]["id"]=="geometry") {
					JSONStorable receiver = atom.GetStorableByID("geometry");JSONArray clothingJSON=storablesJSON[index]["clothing"].AsArray ;
					if(receiver!=null){for (int clothingIndex = 0; clothingIndex < clothingJSON.Count; clothingIndex++){
						JSONStorableBool clothingEnabled = receiver.GetBoolJSONParam("clothing:"+clothingJSON[clothingIndex]["id"]);
						if((string)clothingJSON[clothingIndex]["enabled"]=="true"&& specialMode=="NONE"){ clothingEnabled.val = !reverse;}
					}}				
				}
				else if (!reverse || specialMode!="NONE"){
					JSONStorable receiver = atom.GetStorableByID((string)storablesJSON[index]["id"]);
					if (receiver!=null){
						foreach (string boolParamName in receiver.GetBoolParamNames()){
							if (storablesJSON[index][boolParamName]!=null&& specialMode=="NONE"){receiver.GetBoolJSONParam(boolParamName).val=((string)storablesJSON[index][boolParamName]=="true");}
							if (boolParamName=="allowDetach" && specialMode =="UNDRESS"){receiver.GetBoolJSONParam(boolParamName).val=!reverse;}
							if (boolParamName=="simEnabled" && specialMode =="RESETSIM"){receiver.CallAction("Reset");}
						}
						foreach (string colorParamName in receiver.GetColorParamNames()){
							if (storablesJSON[index][colorParamName]!=null){HSVColor color ;color.H = storablesJSON[index][colorParamName]["h"].AsFloat;color.S = storablesJSON[index][colorParamName]["s"].AsFloat;color.V = storablesJSON[index][colorParamName]["v"].AsFloat;	receiver.GetColorJSONParam(colorParamName).val=color;}
						}
						foreach (string floatParamName in receiver.GetFloatParamNames()){if (storablesJSON[index][floatParamName]!=null){receiver.GetFloatJSONParam(floatParamName).val=storablesJSON[index][floatParamName].AsFloat;}}
						foreach (string stringParamName in receiver.GetStringParamNames()){if (storablesJSON[index][stringParamName]!=null){receiver.GetStringJSONParam(stringParamName).val=storablesJSON[index][stringParamName];}}
						foreach (string stringChooserParamName in receiver.GetStringChooserParamNames()){if (storablesJSON[index][stringChooserParamName]!=null){receiver.GetStringChooserJSONParam(stringChooserParamName).val=storablesJSON[index][stringChooserParamName];}}
						foreach (string urlParamName in receiver.GetUrlParamNames()){if (storablesJSON[index][urlParamName]!=null){receiver.GetUrlJSONParam(urlParamName).val=storablesJSON[index][urlParamName];}}
						foreach (string vector3ParamName in receiver.GetVector3ParamNames()){
							if (storablesJSON[index][vector3ParamName]!=null){Vector3 vector ;JSONArray vector3Array = storablesJSON[index][vector3ParamName].AsArray ;vector.x = vector3Array[0].AsFloat;vector.y = vector3Array[1].AsFloat;vector.z = vector3Array[2].AsFloat;receiver.GetVector3JSONParam(vector3ParamName).val=vector;}
						}					
					}
				}
			}
		}
		protected void StartActions(){
			try {
				if (_ifConditionJSON.val=="Always" || (_ifConditionJSON.val=="vBOOL is TRUE" && GetIfBoolState())|| (_ifConditionJSON.val=="vBOOL is FALSE" && !GetIfBoolState())){
					Atom nextActionAtom =null;	JSONStorable nextActionReceiver = null;		
					foreach (GroupAction action in _randomActList){	
						if (PlayActDecision(action._actProbability.val)){
							nextActionAtom = SuperController.singleton.GetAtomByUid(action._atomNameActStart.val);
							string actionType = action._actionTypeStart.val;
							if (nextActionAtom == null)	{SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load Atom ("+action._atomNameActStart.val+") for Action "+action._randomActID.ToString());}
							else if (actionType.Substring(0,Mathf.Min(4,actionType.Length))!="LOAD" && actionType.Substring(0,Mathf.Min(5,actionType.Length))!="MERGE" && actionType!="UNDRESS" ){
								nextActionReceiver = nextActionAtom.GetStorableByID (action._receiverNameActStart.val);
								if (nextActionReceiver == null)	{SuperController.LogMessage("Action Grouper ("+this.storeId+") was unable to load Receiver ("+action._receiverNameActStart.val+") for Action "+action._randomActID.ToString());}
								else{PlayAction(actionType,nextActionAtom, nextActionReceiver,action._targetNameActStart.val,action._targetValueStart.val,action._targetFloatValueStart.val,action._targetColorValueStart.val,action._targetFileURLValueStart.val,action._targetValueSource.val,action._targetVUMLVariableName.val);}
							}
							else {PlayAction(actionType,nextActionAtom, nextActionReceiver,action._targetNameActStart.val,action._targetValueStart.val,action._targetFloatValueStart.val,action._targetColorValueStart.val,action._targetFileURLValueStart.val);}
						}
					}
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected NamedAudioClip GetAudioClip(string fullClipName){
			string clipName ;NamedAudioClip clip;int index = fullClipName.IndexOf(":");
			if (index > 0 && fullClipName.Length>=index){clipName=fullClipName.Substring (0, index);clip = EmbeddedAudioClipManager.singleton.GetClip(clipName);}
			else{clipName = fullClipName;clip = URLAudioClipManager.singleton.GetClip(clipName);}
			return clip;
		}
		protected void TestAction(){
			try {
				Atom nextActionAtom ;	JSONStorable nextActionReceiver =null;	GroupAction action ;_randomActDict.TryGetValue(_currentActionChooser.val, out action) ;nextActionAtom = SuperController.singleton.GetAtomByUid(action._atomNameActStart.val);
				
				if (nextActionAtom==null){SuperController.LogMessage("Atom "+action._atomNameActStart.val+" does not exist any longer.");}
				else {
					if (action._receiverNameActStart.val!="Load Look/Pose/Preset" && action._receiverNameActStart.val!="Dress/Undress Clothing"){	nextActionReceiver = nextActionAtom.GetStorableByID (action._receiverNameActStart.val);	}
					if (nextActionReceiver!=null || action._receiverNameActStart.val!="Load Look/Pose/Preset" || action._receiverNameActStart.val!="Dress/Undress Clothing"){PlayAction(action._actionTypeStart.val,nextActionAtom,nextActionReceiver,action._targetNameActStart.val,action._targetValueStart.val,action._targetFloatValueStart.val,action._targetColorValueStart.val,action._targetFileURLValueStart.val,action._targetValueSource.val,action._targetVUMLVariableName.val);}
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void AddAction(){
			try {string newActName = CreateNextAct();UpdateActChooserList();_currentActionChooser.val = newActName ;_atom1JSON.val = containingAtom.name;}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void CopyFromActToAct(GroupAction currentAct, GroupAction newAct){
			newAct._atomNameActStart.val = currentAct._atomNameActStart.val; newAct._receiverGroupNameActStart.val = currentAct._receiverGroupNameActStart.val; newAct._receiverNameActStart.val = currentAct._receiverNameActStart.val; newAct._targetNameActStart.val = currentAct._targetNameActStart.val ; newAct._targetValueStart.val = currentAct._targetValueStart.val ; newAct._actionTypeStart.val = currentAct._actionTypeStart.val ; newAct._actProbability.val = currentAct._actProbability.val ;newAct._targetColorValueStart.val = currentAct._targetColorValueStart.val ;newAct._targetFloatValueStart.val = currentAct._targetFloatValueStart.val ; newAct._targetFileURLValueStart.val = currentAct._targetFileURLValueStart.val ; newAct._targetValueSource.val = currentAct._targetValueSource.val;newAct._targetVUMLVariableName.val = currentAct._targetVUMLVariableName.val;
		}
		protected void CopyAction(){
			try{	
				string newActName = CreateNextAct();GroupAction newAct ;GroupAction currentAct ;_randomActDict.TryGetValue(newActName, out newAct) ;_randomActDict.TryGetValue(_currentActionChooser.val, out currentAct) ;CopyFromActToAct (currentAct,newAct);UpdateActChooserList();_currentActionChooser.val = newActName ;
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void ActionUp(){
			try {				
				GroupAction tempAction = new GroupAction(0,"CoreControl");GroupAction currentAction;GroupAction altAction;_randomActDict.TryGetValue(_currentActionChooser.val, out currentAction) ;CopyFromActToAct (currentAction,tempAction);
				if (_currentActionChooser.val=="Action 1"){
					for (int actNumber=2; actNumber <= _actCount; actNumber++){_randomActDict.TryGetValue("Action "+actNumber.ToString(), out altAction) ;CopyFromActToAct (altAction,currentAction);_randomActDict.TryGetValue("Action "+actNumber.ToString(), out currentAction) ;}
					CopyFromActToAct (tempAction,currentAction);_currentActionChooser.val = "Action "+_actCount.ToString();
				}else{_randomActDict.TryGetValue("Action "+(currentAction._randomActID-1).ToString(), out altAction) ;CopyFromActToAct (altAction,currentAction);CopyFromActToAct (tempAction,altAction);_currentActionChooser.val = "Action "+(currentAction._randomActID-1).ToString();}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void ActionDown(){
			try {
				GroupAction tempAction = new GroupAction(0,"CoreControl");GroupAction currentAction;GroupAction altAction;_randomActDict.TryGetValue(_currentActionChooser.val, out currentAction) ;CopyFromActToAct (currentAction,tempAction);
				if (_currentActionChooser.val=="Action "+_actCount.ToString()){
					for (int actNumber=(int)(_actCount -1); actNumber >= 1; actNumber--){_randomActDict.TryGetValue("Action "+actNumber.ToString(), out altAction) ;CopyFromActToAct (altAction,currentAction);_randomActDict.TryGetValue("Action "+actNumber.ToString(), out currentAction) ;}
					CopyFromActToAct (tempAction,currentAction);_currentActionChooser.val = "Action 1";
				}else{_randomActDict.TryGetValue("Action "+(currentAction._randomActID+1).ToString(), out altAction) ;CopyFromActToAct (altAction,currentAction);CopyFromActToAct (tempAction,altAction);_currentActionChooser.val = "Action "+(currentAction._randomActID+1).ToString();}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}	
		protected void DeleteAction(){
			try{
				GroupAction currentAct ;GroupAction previousAct ;List<GroupAction> newRandActList = new List<GroupAction>();int deletedActNumber = 0;
				_randomActDict.TryGetValue("Action 1", out previousAct) ;_randomActDict.TryGetValue(_currentActionChooser.val, out currentAct) ;deletedActNumber = currentAct._randomActID ;
				_randomActDict.Clear();_randomActDict = new Dictionary<string, GroupAction>();
				foreach (GroupAction groupAct in _randomActList){
					if (groupAct._randomActID <= deletedActNumber && groupAct._randomActID != _actCount){newRandActList.Add(groupAct);}
					else {
						if (groupAct._randomActID > deletedActNumber){CopyFromActToAct (groupAct,previousAct);}
						if (groupAct._randomActID == _actCount ){
							DeregisterString(groupAct._atomNameActStart);DeregisterString(groupAct._receiverGroupNameActStart);DeregisterString(groupAct._receiverNameActStart);DeregisterString(groupAct._targetNameActStart);DeregisterString(groupAct._targetValueStart);DeregisterString(groupAct._targetValueSource);DeregisterString(groupAct._targetVUMLVariableName);DeregisterString(groupAct._actionTypeStart);DeregisterFloat(groupAct._actProbability);DeregisterFloat(groupAct._targetFloatValueStart);DeregisterColor(groupAct._targetColorValueStart);DeregisterString(groupAct._targetFileURLValueStart);
						}else {newRandActList.Add(groupAct);}
					}	
					previousAct = groupAct;
				}
				_randomActList.Clear();
				foreach (GroupAction groupAct in newRandActList){_randomActList.Add (groupAct);_randomActDict.Add("Action "+groupAct._randomActID.ToString(),groupAct);}				
				_actCount = _actCount - 1;UpdateActChooserList();
				if (deletedActNumber>_actCount){deletedActNumber = _actCount;}
				SwitchAction ("Action "+deletedActNumber.ToString());
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void BulkCopyActions(){
			try	{
				string[] targetName = _bulkOpTargetJSON.val.Split('>');Atom atom = SuperController.singleton.GetAtomByUid (targetName[0]);JSONStorable receiver = atom?.GetStorableByID (targetName[1]);
				if (receiver==null){SuperController.LogMessage("Selected Bulk Copy Target does not exist.");}
				else{
					int actCount = (int) receiver.GetFloatJSONParam("actionCount").val;	
					for (int actNumber=1; actNumber <= actCount; actNumber++){
						string newActName = CreateNextAct();GroupAction newAct ;_randomActDict.TryGetValue(newActName, out newAct) ;
						newAct._atomNameActStart.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Atom1Name").val;newAct._receiverGroupNameActStart.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"ReceiverGroup1Name").val;newAct._receiverNameActStart.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Receiver1Name").val;newAct._targetNameActStart.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Target1Name").val;newAct._actionTypeStart.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Action1TypeName").val;newAct._targetValueStart.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Target1ValueName").val;newAct._targetValueSource.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Target1ValueSource").val;newAct._targetVUMLVariableName.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Target1VUMLVarName").val;newAct._actProbability.val = receiver.GetFloatJSONParam("act"+actNumber.ToString()+"Probability").val;newAct._targetFloatValueStart.val = receiver.GetFloatJSONParam("act"+actNumber.ToString()+"Target1FloatValueName").val;newAct._targetColorValueStart.val = receiver.GetColorJSONParam("act"+actNumber.ToString()+"Target1ColorValueName").val;newAct._targetFileURLValueStart.val = receiver.GetStringJSONParam("act"+actNumber.ToString()+"Target1UrlValueName").val;
						UpdateActChooserList();_currentActionChooser.val = newActName ;
					}						
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void ChangeAtomName(){
			Atom atomOld = SuperController.singleton.GetAtomByUid (_bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7));Atom atomNew = SuperController.singleton.GetAtomByUid (_bulkOpTargetJSON.val);List <string> newAtomReceivers = atomNew.GetStorableIDs ();
			foreach (GroupAction act in _randomActList){	
				if (act._atomNameActStart.val == _bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7)){
					if (newAtomReceivers.Contains(act._receiverNameActStart.val)){act._atomNameActStart.val = _bulkOpTargetJSON.val ;}
					else {SuperController.LogMessage("Action "+act._randomActID.ToString()+" start Receiver is not available in the target Atom, so Atom change was skipped");}
				}
			}
			SwitchAction(_currentActionChooser.val);
		}
		protected void UpdateActChooserList(){
			List <string> actionChoices = new List <string>() ;			
			foreach (GroupAction act in _randomActList){actionChoices.Add("Action "+act._randomActID.ToString());}
			_currentActionChooser.choices= new List<string>();_currentActionChooser.choices = actionChoices;
		}
		protected void SyncBulkOps(){
			try{
				CloseAllPopup(_bulkOpPopup);List <string> bulkOpChoices = new List <string>() ;	bulkOpChoices.Add ("Copy Acts From");
				foreach (GroupAction groupAct in _randomActList){
					if (!bulkOpChoices.Contains("Change "+groupAct._atomNameActStart.val)) {bulkOpChoices.Add("Change "+groupAct._atomNameActStart.val);}
				}
				_bulkOpJSON.choices= new List<string>();_bulkOpJSON.choices = bulkOpChoices;
				if (!_bulkOpJSON.choices.Contains(_bulkOpJSON.val)){_bulkOpJSON.val=_bulkOpJSON.choices[0];}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SyncBulkOpTarget(){
			try{
				CloseAllPopup(_bulkOpTargetPopup);
				List <string> bulkOpTargetChoices = new List <string>() ;	
				foreach (Atom atom in SuperController.singleton.GetAtoms()){
					if (_bulkOpJSON.val.Substring(0,6) == "Change"){
					    Atom bulkAtom = SuperController.singleton.GetAtomByUid (_bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7));
						if (!bulkOpTargetChoices.Contains(atom.uid) && _bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7)!=atom.uid && atom.type==bulkAtom.type) {bulkOpTargetChoices.Add(atom.uid);}
					}
					else{
						foreach (string receiverName in atom.GetStorableIDs()){
							if (_bulkOpJSON.val == "Copy Acts From"){
								if (receiverName.Length >= 13){
									if (receiverName.Substring(receiverName.Length -13,13)=="ActionGrouper"){
										if (!bulkOpTargetChoices.Contains(atom.uid)) {bulkOpTargetChoices.Add(atom.uid+">"+receiverName);}
				}	}	}	}	}	}
				if (bulkOpTargetChoices.Count == 0) {bulkOpTargetChoices.Add("No Target");}
				_bulkOpTargetJSON.choices= bulkOpTargetChoices;
				if (!_bulkOpTargetJSON.choices.Contains(_bulkOpTargetJSON.val)){_bulkOpTargetJSON.val=_bulkOpTargetJSON.choices[0];}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SwitchBulkOp(string bulkOp){SyncBulkOpTarget();}protected void SwitchBulkOpTarget(string bulkOpTarget){}		
		protected void ExecuteBulkOp(){
			try{
				Atom atom ;
				if (_bulkOpTargetJSON.val != "No Target"){
					if (_bulkOpJSON.val == "Copy Acts From"){BulkCopyActions();}
					else if (_bulkOpJSON.val.Substring(0,6) == "Change"){ChangeAtomName();}
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void AtomNameUpdate(string oldName, string newName){
			try{
				_actSwitching =true;
				foreach (GroupAction action in _randomActList){
					if (oldName == action._atomNameActStart.val){action._atomNameActStart.val = newName ;}
					if (action._targetValueSource.val.Contains(oldName)){action._targetValueSource.val=action._targetValueSource.val.Replace(oldName,newName);}
				}				
				if (_atom1JSON.val == oldName){_atom1JSON.val = newName;}
				if (_targetValueSourceJSON.val.Contains(oldName)){_targetValueSourceJSON.val=_targetValueSourceJSON.val.Replace(oldName,newName);}
				if (_whenVUMLPluginJSON.val.Contains(oldName)){_whenVUMLPluginJSON.val=_whenVUMLPluginJSON.val.Replace(oldName,newName);}
				if (_ifVUMLPluginJSON.val.Contains(oldName)){_ifVUMLPluginJSON.val=_ifVUMLPluginJSON.val.Replace(oldName,newName);}
				if (_bulkOpTargetJSON.val.Contains(oldName)){_bulkOpTargetJSON.val=_bulkOpTargetJSON.val.Replace(oldName,newName);}	
				if (_phrasePluginDict!=null){foreach (var kvp in _phrasePluginDict){
					foreach (PluginReference pluginRef in _phrasePluginDict[kvp.Key]){if(pluginRef._atomName==oldName){pluginRef._atomName=newName;}}
				}}
				_actSwitching =false;
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}	
		protected void SelectFile(string fileName){
			try {			
				string filePath ; 
//				string relFilePath ;
				if (fileName ==""){_target1ValueFilePathStringJSON.val = "" ;Target1FileURLValueSelect ("");}
				else{
					if (String.IsNullOrEmpty(fileName)){return;}
//					filePath = fileName.Substring(0,_vamFilePath.Length);
//					if (filePath != _vamFilePath ){SuperController.LogMessage("File must be within VAM directory structure: " + _vamFilePath);return;	}
//					relFilePath = fileName.Substring(_vamFilePath.Length);
					_lastBrowseDir = fileName.Substring(0, fileName.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";
					_target1ValueFilePathStringJSON.val = fileName ;
					Target1FileURLValueSelect (fileName);
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SpeechTextUpdate(string text){try{ _speechTextUpdatedJSON.val =true; if (!_phraseRecogniserActiveJSON.val && _whenConditionJSON.val=="Speech Trigger" && _speechTextJSON.val!="") CheckSpeechTextUpdates();}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false){
			UIDynamicTextField textfield = CreateTextField(jss, rightSide);var input = textfield.gameObject.AddComponent<InputField>();jss.inputField = input; input.lineType = InputField.LineType.MultiLineNewline;input.textComponent = textfield.UItext;input.textComponent.resizeTextMaxSize = 30;input.textComponent.resizeTextForBestFit = true;textfield.backgroundColor = Color.white;
			return(textfield);
		}
        private void OnPhraseRecognized(PhraseRecognizedEventArgs args){
			try{
				if (_phrasePluginDict.ContainsKey (args.text)){
					foreach (PluginReference pluginRef in _phrasePluginDict[args.text]){
						Atom atom = SuperController.singleton.GetAtomByUid(pluginRef._atomName);JSONStorable pluginReceiver = atom.GetStorableByID(pluginRef._pluginName);JSONStorableStringChooser whenCondition = pluginReceiver.GetStringChooserJSONParam("whenCondition");JSONStorableBool speechHighConfidence = pluginReceiver.GetBoolJSONParam("SpeechHighConfidence");
						if (whenCondition.val =="Speech Trigger"&& (!speechHighConfidence.val || args.confidence == ConfidenceLevel.High)){pluginReceiver.CallAction("Execute");}						
					}
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		private void StopSpeechRecognizer(){if (_recognizer != null){ _recognizer.OnPhraseRecognized -= OnPhraseRecognized;_recognizer.Stop();PhraseRecognitionSystem.Shutdown();_recognizer = null; }}
        void OnDestroy() {StopSpeechRecognizer();SuperController.singleton.onAtomUIDRenameHandlers -= _atomRenameHandle;}
		void OnDisable(){StopSpeechRecognizer();}void OnEnable(){SpeechTextUpdate(_speechTextJSON.val);}
		void Start() {
			try	{
				_actSwitching=false;
				if (_enableAutoStart.val) {_autoStart=true;} else {_autoStart=false;}
				if (_actCount == 0){CreateNextAct();UpdateActChooserList();	_currentActionChooser.val = _currentActionChooser.choices[0];_atom1JSON.val = containingAtom.name;}
				else{UpdateActChooserList();_currentActionChooser.val = _currentActionChooser.choices[0];}	
				if (_whenConditionJSON.val.Length>4 && _whenConditionJSON.val.Substring(0,5)=="vBOOL"){_whenVBOOLStartState = GetWhenBoolState ();}
				SpeechTextUpdate(_speechTextJSON.val);
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		private bool CheckSpeechTextUpdates(){
			int activePhraseRecogniserCount =0 ;bool speechTextUpdate =false;
			foreach (Atom atom in SuperController.singleton.GetAtoms()){
				Transform pluginsTransform = null;
				if (atom.name == "CoreControl")  pluginsTransform = atom.transform.Find("ScenePluginManager")?.Find("Plugins");
				else pluginsTransform = atom.transform.Find("reParentObject")?.Find("object")?.Find("PluginManager")?.Find("Plugins");
				if (pluginsTransform!=null){
					for (int i = 0; i < pluginsTransform.childCount; i++){
						string receiverName =pluginsTransform.GetChild(i).gameObject.name;
						if (receiverName.EndsWith("ActionGrouper")){
							JSONStorable receiver = atom.GetStorableByID(receiverName);
							if (receiver!=null){
								JSONStorableBool targetRecogniser = receiver.GetBoolJSONParam("PhraseRecogniserActive");JSONStorableBool speechTextUpdated = receiver.GetBoolJSONParam("SpeechTextUpdate");
								if (targetRecogniser!=null && targetRecogniser.val){activePhraseRecogniserCount++;}
								if (speechTextUpdated!=null && speechTextUpdated.val){speechTextUpdate=true;}
							}
						}
					}
				}
			}
			if (activePhraseRecogniserCount>1){SuperController.LogMessage("Action Grouper: more than one active Phrase Recogniser was detected. Only one should be running!");}
			else if (activePhraseRecogniserCount==0){_phraseRecogniserActiveJSON.val = true;PhraseRecognitionSystem.Restart();RefreshPhraseRecogniser();}			
			return (speechTextUpdate);
		}
		private void RefreshPhraseRecogniser(){
			StopSpeechRecognizer();
			if(_phrasePluginDict!=null)_phrasePluginDict.Clear();
			_phrasePluginDict = new Dictionary<string, List<PluginReference>>();List<string> phraseList = new List<string>();		
			foreach (Atom atom in SuperController.singleton.GetAtoms()){
				Transform pluginsTransform = null;
				if (atom.name == "CoreControl")  pluginsTransform = atom.transform.Find("ScenePluginManager")?.Find("Plugins");
				else pluginsTransform = atom.transform.Find("reParentObject")?.Find("object")?.Find("PluginManager")?.Find("Plugins");
				if (pluginsTransform!=null){
					
					for (int i = 0; i < pluginsTransform.childCount; i++){
						string receiverName =pluginsTransform.GetChild(i).gameObject.name;
						if (receiverName.EndsWith("ActionGrouper")){
							JSONStorable receiver = atom.GetStorableByID(receiverName);
							if (receiver!=null){								
								JSONStorableString speechTextJSON = receiver.GetStringJSONParam("SpeechText");
								if (speechTextJSON!=null && speechTextJSON.val!=""){
									string[] keywordsArray = speechTextJSON.val.Split(',').Select(keyword => keyword.Trim().ToUpper()).Distinct().ToArray();
									foreach (string keyword in keywordsArray){						
										if (!phraseList.Contains(keyword)){phraseList.Add(keyword);List <PluginReference> newPluginRefList = new List<PluginReference>();_phrasePluginDict.Add(keyword,newPluginRefList);}							
										PluginReference newPluginRef = new PluginReference();newPluginRef._atomName = atom.name;newPluginRef._pluginName = receiverName;_phrasePluginDict[keyword].Add(newPluginRef);
									}
								}
								JSONStorableBool speechTextUpdated = receiver.GetBoolJSONParam("SpeechTextUpdate");
								speechTextUpdated.val = false;
							}
						}
					}
				}
			}
			if (phraseList.Count>0){_recognizer = new KeywordRecognizer (phraseList.ToArray());_recognizer.OnPhraseRecognized += OnPhraseRecognized;_recognizer.Start();}
		}
		void Update() {
			try {
				bool speechTextUpdates = false;
				if ( _phraseRecogniserActiveJSON.val || (_whenConditionJSON.val=="Speech Trigger" && _speechTextJSON.val!="")) speechTextUpdates=CheckSpeechTextUpdates();
				if ( _phraseRecogniserActiveJSON.val && speechTextUpdates)RefreshPhraseRecogniser();
				if (SuperController.singleton.freezeAnimation == false){if (_autoStart || _whenConditionJSON.val == "Continuous"){_autoStart = false; StartActions();}}
				if (_whenConditionJSON.val.Length>4 && _whenConditionJSON.val.Substring(0,5)=="vBOOL" && _whenVBOOLStartState!=GetWhenBoolState() ){
					bool currentWhenBoolState = GetWhenBoolState();
					if (_whenConditionJSON.val=="vBOOL turns TRUE" && currentWhenBoolState){StartActions();}
					if (_whenConditionJSON.val=="vBOOL turns FALSE" && !currentWhenBoolState){StartActions();}
					if (_whenConditionJSON.val=="vBOOL changes"){StartActions();}			
					_whenVBOOLStartState=currentWhenBoolState;}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		private KeywordRecognizer _recognizer = null;bool _whenVBOOLStartState = false; int _actCount =0;
		Atom GetCurrentActionAtom (){return(SuperController.singleton.GetAtomByUid(_atom1JSON.val));}
		protected JSONStorable _receiver1; protected JSONStorable _bulkReceiver;protected JSONStorableAction _startActions;	protected JSONStorableStringChooser _currentActionChooser; protected JSONStorableStringChooser _atom1JSON;protected JSONStorableStringChooser _receiverGroup1JSON;  protected JSONStorableStringChooser _receiver1JSON; protected JSONStorableStringChooser _target1JSON;protected JSONStorableStringChooser _target1ValueChoicesJSON; protected JSONStorableStringChooser _bulkOpJSON; protected JSONStorableStringChooser _bulkOpTargetJSON; protected JSONStorableStringChooser _importPluginJSON;protected JSONStorableStringChooser _whenConditionJSON;protected JSONStorableStringChooser _whenVUMLPluginJSON;protected JSONStorableStringChooser _whenVUMLVariableJSON;protected JSONStorableStringChooser _ifConditionJSON;protected JSONStorableStringChooser _ifVUMLPluginJSON;protected JSONStorableStringChooser _ifVUMLVariableJSON;  protected JSONStorableFloat _target1ValueFloatJSON ;protected JSONStorableFloat _probabilityWeight ;protected JSONStorableStringChooser _targetValueSourceJSON ; protected JSONStorableStringChooser _targetVUMLVariableNameJSON ;protected JSONStorableColor _target1ValueColorJSON ;	protected JSONStorableString _target1ValueFilePathStringJSON ;protected JSONStorableString _pluginVersionJSON;		protected JSONStorableString _speechTextJSON;protected JSONStorableBool _hideVAMSaveRestoreActions ; protected JSONStorableBool _enableAutoStart ; protected JSONStorableBool _speechHighConfidenceJSON ; protected JSONStorableBool _speechTextUpdatedJSON ; protected JSONStorableBool _phraseRecogniserActiveJSON ;
		protected bool _actSwitching = false;private bool _autoStart =false; 	protected string _currentActName ="" ;string _vamFilePath ; private string _lastBrowseDir;	protected string _importFileName = "";
		protected UIDynamicPopup _bulkOpPopup;protected UIDynamicPopup _bulkOpTargetPopup;  protected UIDynamicSlider _displayProbSlider; protected UIDynamicPopup _displayActPopup;protected UIDynamicPopup _displayAtomPopup;protected UIDynamicPopup _displayReceiverGroupPopup;protected UIDynamicPopup _displayReceiverPopup;protected UIDynamicPopup _displayTargetPopup;		protected UIDynamicPopup _displayTargetValueSourcePopup;protected UIDynamicPopup _displayTargetVUMLVarPopup;protected UIDynamicPopup _displayTargetValuePopup;protected UIDynamicPopup _selectActionGrouperPluginPopup;protected UIDynamicPopup _whenTriggerConditionPopup;protected UIDynamicPopup _whenVUMLPluginPopup;protected UIDynamicPopup _whenVUMLVariablePopup;protected UIDynamicPopup _ifConditionPopup;protected UIDynamicPopup _ifVUMLPluginPopup;protected UIDynamicPopup _ifVUMLVariablePopup;protected UIDynamicSlider _displayTargetValueFloatPopup;protected UIDynamicColorPicker _displayTargetValueColorPopup;protected UIDynamicButton _displayTestActionButton;protected UIDynamicButton _displayActionUpButton;protected UIDynamicButton _displayActionDownButton;protected UIDynamicButton _displayFileSelectButton;protected UIDynamicButton _addActionButton;protected UIDynamicButton _copyActionButton;protected UIDynamicButton _deleteActionButton;protected UIDynamicButton _executeBulkOpButton;protected UIDynamicButton _selectImportSceneButton;protected UIDynamicButton _importActionsButton;protected UIDynamicToggle _displayHSVRToggle;protected UIDynamicToggle _speechHighConfidenceToggle;protected UIDynamic _spacer;protected UIDynamic _spacer2; protected UIDynamic _leftSpacer1;protected UIDynamic _leftSpacer2;protected UIDynamic _leftSpacer3;protected UIDynamic _leftSpacer4;protected UIDynamicTextField _displayLoadFilePath ;protected UIDynamicTextField _pluginVersionTextField ;protected UIDynamicTextField _speechTextField ;protected UIDynamicButton _displayClearFileSelectButton;
        List<GroupAction> _randomActList = new List<GroupAction>();List<string> _actionChoices = new List<string>();Dictionary<string, GroupAction> _randomActDict = new Dictionary<string, GroupAction>();Dictionary<string, List<PluginReference>> _phrasePluginDict;
		SuperController.OnAtomUIDRename _atomRenameHandle ;
	}
	public class PluginReference{public string _atomName ="";public string _pluginName ="";}
	public class GroupAction{
        public GroupAction(int aActID, string atomName) {
			_randomActID = aActID;_atomNameActStart = new JSONStorableString("act"+aActID.ToString()+"Atom1Name" ,"");_atomNameActStart.val = atomName ;_atomNameActStart.storeType = JSONStorableParam.StoreType.Physical;_receiverGroupNameActStart = new JSONStorableString("act"+aActID.ToString()+"ReceiverGroup1Name" , "");_receiverGroupNameActStart.val = "Other" ;_receiverGroupNameActStart.storeType = JSONStorableParam.StoreType.Physical;_receiverNameActStart = new JSONStorableString("act"+aActID.ToString()+"Receiver1Name" , "");_receiverNameActStart.val = "GlobalLighting" ;	_receiverNameActStart.storeType = JSONStorableParam.StoreType.Physical;	_targetNameActStart = new JSONStorableString("act"+aActID.ToString()+"Target1Name", "");_targetNameActStart.val = "showSkybox";	_targetNameActStart.storeType = JSONStorableParam.StoreType.Physical;_actionTypeStart = new JSONStorableString("act"+aActID.ToString()+"Action1TypeName", "");_actionTypeStart.val = "BOOL";_actionTypeStart.storeType = JSONStorableParam.StoreType.Physical;	_targetValueStart = new JSONStorableString("act"+aActID.ToString()+"Target1ValueName", "*?*");_targetValueStart.val = "n/a";_targetValueStart.storeType = JSONStorableParam.StoreType.Physical;			_targetValueSource = new JSONStorableString("act"+aActID.ToString()+"Target1ValueSource", "*?*");_targetValueSource.val = "Static";	_targetValueSource.storeType = JSONStorableParam.StoreType.Physical;_targetVUMLVariableName = new JSONStorableString("act"+aActID.ToString()+"Target1VUMLVarName", "*?*");_targetVUMLVariableName.val = "None";	_targetVUMLVariableName.storeType = JSONStorableParam.StoreType.Physical;_targetFloatValueStart = new JSONStorableFloat("act"+aActID.ToString()+"Target1FloatValueName", -10000000000f, 0f, 10000000000f);_targetFloatValueStart.val = 0f;_targetFloatValueStart.storeType = JSONStorableParam.StoreType.Physical;HSVColor hsvColor;hsvColor.H = 0f;hsvColor.S = 0f;hsvColor.V = 0f;_targetColorValueStart = new JSONStorableColor("act"+aActID.ToString()+"Target1ColorValueName", hsvColor);	_targetColorValueStart.storeType = JSONStorableParam.StoreType.Physical;_targetFileURLValueStart = new JSONStorableString("act"+aActID.ToString()+"Target1UrlValueName", "*?*");_targetFileURLValueStart.val = "";	_targetFileURLValueStart.storeType = JSONStorableParam.StoreType.Physical;_actProbability = new JSONStorableFloat("act"+aActID.ToString()+"Probability" ,-1f, 0f, 100000000f);_actProbability.val = 1f;	_actProbability.storeType = JSONStorableParam.StoreType.Physical;
		}	
		public int _randomActID ;	public JSONStorableString _atomNameActStart ;public JSONStorableString _receiverGroupNameActStart ;public JSONStorableString _receiverNameActStart ;	public JSONStorableString _targetNameActStart ;	public JSONStorableString _actionTypeStart; public JSONStorableString _targetValueStart ; public JSONStorableFloat _targetFloatValueStart ; public JSONStorableColor _targetColorValueStart ; public JSONStorableString _targetFileURLValueStart ;public JSONStorableFloat _actProbability ;public JSONStorableString _targetValueSource ; public JSONStorableString _targetVUMLVariableName ;
	}
}